C    *****************************************************
C
C                    CrGraph Package V2.0
C                       BAND Program
C
C      Theoretical Chemistry Group - University of Torino
C      Adapted by Ales Zupan - University of Lubiana
C
C     *****************************************************
      PROGRAM BAND
      CHARACTER*10 LBL(60)
      CHARACTER*50 LLABEL,DLABEL
      COMMON /FILES/IPLOT,ISCR,IMF,IIN,IUHF,IFERMI
      COMMON /CONT/XMM,YMM,NCOLL,NCOLH,RL,RU,RS,WINTER,
     *XLSPC1,RSPC,XLTICK,XLSPC,YMIN,YMAN
      COMMON /RPL/NROW,NCOL,X0,Y0,DX,DY,COSXY
      DIMENSION W(60)
      IIN=5 
      IPLOT=25
      ISCR=19
      IMF=18
      WRITE(*,100)'Band program'
      WRITE(*,100)
      WRITE(*,100)'Extracting band data from fortran unit 25'
      CALL EXTRACT(ISEG,ISEGA,W)
      IF(IUHF.NE.0)THEN
      IVLINE=ISEGA-ISEG
      ISEG=ISEG/2
      ISEGA=ISEG+(IVLINE+1)/2
      DO 1 I=ISEGA,20
1     W(I)=0. 
      ENDIF
      CALL INIT(DLABEL,LLABEL,LBL,ISEGA)
      REWIND(ISCR)
      CALL FINDMM(ISEG,NCOLL,NCOLH,BMIN,BMAX)
      REWIND(ISCR)
      WRITE(*,100)'Creating metafile'
      CALL MAKEMF(ISEGA,W,DLABEL,LLABEL,LBL)
100   FORMAT(1X,80A)
      END
      SUBROUTINE EXTRACT(ISEG,ISEGA,W)
      COMMON /FILES/IPLOT,ISCR,IMF,IIN,IUHF,IFERMI
      COMMON /CONT/XMM,YMM,NCOLL,NCOLH,RL,RU,RS,WINTER,
     *XLSPC1,RSPC,XLTICK,XLSPC,YMIN,YMAX
      COMMON /RPL/NROW,NCOL,X0,Y0,DX,DY,COSXY
      DIMENSION W(60)
      DIMENSION RMAT(100000)
      CHARACTER*4 TY
      DO 20 IC=1,20
20    W(IC)=0.
      ISEG=0
      ISEGA=0
      IORIG=1
10    READ(IPLOT,200,END=999)MARK,TY,NRDU,NCDU,DXDU,DYDU,COSDU
      NELEM=NRDU*NCDU
      IF(TY.EQ.'BAND')THEN
      READ(IPLOT,260)X0,Y0
      READ(IPLOT,250,END=999)IC1,IC2,IC3,IC4,IC5,IC6
      NROW=NRDU
      NCOL=NCDU
      DX=DXDU
      DY=DYDU
      COSXY=COSDU
      IF(ISEG.NE.0)THEN
c *** check if the extremes of adjacent segments are coincident
      IF((IC1.NE.I4).OR.(IC2.NE.I5).OR.(IC3.NE.I6))THEN
      ISEGA=ISEGA+1
      W(ISEGA)=0.0
      IORIG=1
      ENDIF
      ENDIF
      ISEG=ISEG+1
      ISEGA=ISEGA+1
      W(ISEGA)=(NCOL-IORIG)*DY
      WRITE(ISCR,200)MARK,TY,NROW,NCOL,DX,DY,COSXY
      WRITE(ISCR,260)X0,Y0
      WRITE(ISCR,250)IC1,IC2,IC3,IC4,IC5,IC6
      IF(MARK.GT.1)IFERMI=1
      IUHF=MOD(MARK,2)
      IORIG=0
      I4=IC4
      I5=IC5
      I6=IC6
      READ(IPLOT,260)(RMAT(II),II=1,NELEM)
      WRITE(ISCR,260)(RMAT(II),II=1,NELEM)
      ELSE
      READ(IPLOT,200)
      READ(IPLOT,221)nadum
      READ(IPLOT,260)(RJUNK,II=1,NELEM)
      IF(TY.EQ.'MAPN') THEN
      DO II=1,nadum
      read(iplot,250)idum
      enddo
      read(iplot,110)(adum,i=1,9)
110   FORMAT(3E20.12)
      endif
      ENDIF
      GOTO 10
999   IF(ISEG.EQ.0)THEN
      WRITE(*,210)
      STOP
      ENDIF
      ISEGA=ISEGA+1
      W(ISEGA)=0.0
      REWIND ISCR
      REWIND IPLOT
200   FORMAT(3X,I1,A4,2I5,1P,(3E12.5))
210   FORMAT(' BAND - BAND DATA NOT FOUND ON FORT.25')
221   format(40X,I4)
250   FORMAT(6I5)
260   FORMAT(6(1PE12.5))
      RETURN
      END
      SUBROUTINE FINDMM(ISEG,NCOLL,NCOLH,BMIN,BMAX)
      COMMON /FILES/IPLOT,ISCR,IMF,IIN,IUHF,IFERMI
      COMMON /RPL/NROW,NCOL,X0,Y0,DX,DY,COSXY
      DIMENSION RMAT(100000)
      BMIN=RMAT(NCOLL)
      BMAX=RMAT(NCOLL)
      DO 1 II=1,ISEG
      CALL RPLOT(ISCR,RMAT)
      DO 1 I=NCOLL,NCOLH
      DO 1 J=1,NCOL
      BMAX=MAX(RMAT((J-1)*NROW+I),BMAX)
      BMIN=MIN(RMAT((J-1)*NROW+I),BMIN)
1     CONTINUE
      REWIND ISCR
      RETURN
      END
      SUBROUTINE INIT(DLABEL,LLABEL,LBL,ISEGA)
      CHARACTER*50 DLABEL,LLABEL
      CHARACTER*10 LBL(60)
      COMMON /FILES/IPLOT,ISCR,IMF,IIN,IUHF,IFERMI
      COMMON /RPL/NROW,NCOL,X0,Y0,DX,DY,COSXY
      COMMON /CONT/XMM,YMM,NCOLL,NCOLH,RL,RU,RS,WINTER,
     *XLSPC1,RSPC,XLTICK,XLSPC,YMIN,YMAX
      DATA A4W,A4H/180.D0,240.D0/
      IIN=5
      READ(IIN,*)XMM,YMM
      IF(XMM.GT.A4W)THEN
      WRITE(*,102)XMM,A4W
      XMM=A4W
      ENDIF
      IF(YMM.GT.A4H)THEN
      WRITE(*,103)YMM,A4H
      YMM=A4H
      ENDIF
c *** scaling to match doss and band energy scale
      ymm=ymm/0.9D0
      READ(IIN,*)NCOLL,NCOLH
      IF((NCOLH-NCOLL+1).GT.NROW)THEN
      PRINT *,' THERE ARE ONLY ',NROW,' BANDS'
      PRINT *,' YOU ASKED FOR ',(NCOLH-NCOLL+1)
      PRINT *, NROW,' WILL BE VISUALIZED'
      NCOLH=NCOLL+NROW-1
      ENDIF
      IF(NCOLH.GT.NROW)THEN
      PRINT *,' THERE ARE ONLY ',NROW,' BANDS'
      PRINT *,' YOU ASKED FOR TOP BAND ',NCOLH
      PRINT *,' BANDS PRINTED UP TO BAND',NROW,' WRITTEN IN FORT.25'
      NCOLH=NROW
C      STOP
      ENDIF
      IF(NCOLL.LE.0)THEN
      PRINT *,' LOWEST BAND CAN NOT BE LE 0'
      STOP
      ENDIF
      READ(IIN,100)DLABEL
      READ(IIN,100)LLABEL
      READ(IIN,*)YMIN,YMAX,RS
      PRINT *,' ENERGY RANGE: ',YMIN,YMAX,' AU'
      RU=YMAX
      RL=NINT(YMIN/RS)
      RL=RL*RS+RS
      DO 1 I=1,ISEGA
      READ(IIN,101)LBL(I)
1     CONTINUE
c     XLSPC1=0.08
c     XLSPC=0.1
      XLSPC1=0.1
      XLSPC=0.
      RSPC=0.05
      WINTER=0.03
      XLTICK=0.007
      RETURN
100   FORMAT(A50)
101   FORMAT(A10)
102   FORMAT(' WIDTH ',F7.1,' REDUCED TO A4',F7.1)
103   FORMAT(' HEIGTH',F7.1,' REDUCED TO A4',F7.1)
      END
      SUBROUTINE MAKEMF(ISEGA,W,DLABEL,LLABEL,LBL)
      COMMON /FILES/IPLOT,ISCR,IMF,IIN,IUHF,IFERMI
      COMMON /CONT/XMM,YMM,NCOLL,NCOLH,RL,RU,RS,WINTER,
     *XLSPC1,RSPC,XLTICK,XLSPC,YMIN,YMAX
      COMMON /RPL/NROW,NCOL,X0,Y0,DX,DY,COSXY
      DIMENSION W(60),YOLD(100000)
      DIMENSION RMAT(100000)
      CHARACTER*50 DLABEL,LLABEL
      CHARACTER*10 LBL(60)
      CHARACTER*4 LINTYP(2)
      DATA LINTYP/'CONT','DASH'/
      WRITE(IMF,111)XMM,YMM
      WRITE(IMF,107)0.05*0.7*YMM
      XMMEFF=XMM-(XLSPC1+RSPC+XLSPC)*XMM
      YMMEFF=YMM-0.1*YMM
      WW=0.
      DO 1 I=1,ISEGA
      IF((W(I).EQ.0.0).AND.(I.NE.ISEGA))THEN
      XMMEFF=XMMEFF-WINTER*XMM
      ELSE
      WW=WW+W(I)
      ENDIF
1     CONTINUE
      XSCALE=XMMEFF/WW
      YSCALE=YMMEFF/(YMAX-YMIN)
      X=(XLSPC1+XLSPC)*XMM
      XOLD=X
c *** drawing vertical lines and symbols
      DO 2 I=1,ISEGA
      WRITE(IMF,101)X,0.1*YMM,X,YMM
      WRITE(IMF,103)X,0.05*YMM,LBL(I)
      IF(W(I).EQ.0.0)THEN
      WRITE(IMF,101)XOLD,0.1*YMM,X,0.1*YMM
      WRITE(IMF,101)XOLD,YMM,X,YMM
      X=X+WINTER*XMM
      XOLD=X
      ELSE
      X=X+W(I)*XSCALE
      ENDIF
2     CONTINUE
      XSAVE=X
      XSCALE=XMMEFF/WW
      DO 3 IU=1,IUHF+1
c     if(iu.gt.1)write(imf,100)'NEWP'
      WRITE(IMF,100)LINTYP(IU)
      IORIG=1
      X=XSAVE
      X3=(XLSPC1+XLSPC)*XMM
      DO 3 I=1,ISEGA-1
      IF(W(I).EQ.0.0)THEN
      X3=X3+WINTER*XMM
      IORIG=1
      ELSE
      CALL RPLOT(ISCR,RMAT)
      XSTEP=W(I)*XSCALE/(NCOL-IORIG)
      DO 4 JJ=NCOLL,NCOLH
      IF(IORIG.GT.0)THEN
      XSTART=X3+XSTEP
      X=XSTART
      XOLD=X3
      Y1=RMAT(JJ)
      Y2=RMAT(NROW+JJ)
      IF(Y1.GE.YMIN.AND.Y2.GE.YMIN.AND.Y1.LE.YMAX.AND.Y2.LE.YMAX)
     *THEN
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ELSEIF(Y2.GT.YMAX.AND.Y1.LT.YMAX.AND.Y1.GT.YMIN)THEN
      AMM=(Y2-Y1)/(X-XOLD)
      ANN=Y2-AMM*X
      Y2=YMAX
      X=(YMAX-ANN)/AMM
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ELSEIF(Y1.GT.YMAX.AND.Y2.LT.YMAX.AND.Y2.GT.YMIN)THEN
      AMM=(Y2-Y1)/(X-XOLD)
      ANN=Y2-AMM*X
      Y1=YMAX
      XOLD=(YMAX-ANN)/AMM
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ELSEIF(Y1.LT.YMIN.AND.Y2.GT.YMIN.AND.Y2.LT.YMAX)THEN
      AMM=(Y2-Y1)/(X-XOLD)
      ANN=Y2-AMM*X
      Y1=YMIN
      XOLD=(YMIN-ANN)/AMM
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ELSEIF(Y2.LT.YMIN.AND.Y1.GT.YMIN.AND.Y1.LT.YMAX)THEN
      AMM=(Y2-Y1)/(X-XOLD)
      ANN=Y2-AMM*X
      Y2=YMIN
      X=(YMIN-ANN)/AMM
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ENDIF
      ELSE
      XSTART=X3+XSTEP
      X=XSTART
      XOLD=X3
      Y1=YOLD(JJ)
      Y2=RMAT(JJ)
      IF(Y1.GE.YMIN.AND.Y2.GE.YMIN.AND.Y1.LE.YMAX.AND.Y2.LE.YMAX)
     *THEN
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ELSEIF(Y2.GT.YMAX.AND.Y1.LT.YMAX.AND.Y1.GT.YMIN)THEN
      AMM=(Y2-Y1)/(X-XOLD)
      ANN=Y2-AMM*X
      Y2=YMAX
      X=(YMAX-ANN)/AMM
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ELSEIF(Y1.GT.YMAX.AND.Y2.LT.YMAX.AND.Y2.GT.YMIN)THEN
      AMM=(Y2-Y1)/(X-XOLD)
      ANN=Y2-AMM*X
      Y1=YMAX
      XOLD=(YMAX-ANN)/AMM
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ELSEIF(Y1.LT.YMIN.AND.Y2.GT.YMIN.AND.Y2.LT.YMAX)THEN
      AMM=(Y2-Y1)/(X-XOLD)
      ANN=Y2-AMM*X
      Y1=YMIN
      XOLD=(YMIN-ANN)/AMM
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ELSEIF(Y2.LT.YMIN.AND.Y1.GT.YMIN.AND.Y1.LT.YMAX)THEN
      AMM=(Y2-Y1)/(X-XOLD)
      ANN=Y2-AMM*X
      Y2=YMIN
      X=(YMIN-ANN)/AMM
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ENDIF
      ENDIF
      XOLD=X
      Y1=Y2
      DO 15 J=2+IORIG,NCOL
      X=XSTART+(J-1-IORIG)*XSTEP
      Y2=RMAT((J-1)*NROW+JJ)
      IF(Y1.GE.YMIN.AND.Y2.GE.YMIN.AND.Y1.LE.YMAX.AND.Y2.LE.YMAX)
     *THEN
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ELSEIF(Y2.GT.YMAX.AND.Y1.LT.YMAX.AND.Y1.GT.YMIN)THEN
      AMM=(Y2-Y1)/(X-XOLD)
      ANN=Y2-AMM*X
      Y2=YMAX
      X=(YMAX-ANN)/AMM
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ELSEIF(Y1.GT.YMAX.AND.Y2.LT.YMAX.AND.Y2.GT.YMIN)THEN
      AMM=(Y2-Y1)/(X-XOLD)
      ANN=Y2-AMM*X
      Y1=YMAX
      XOLD=(YMAX-ANN)/AMM
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ELSEIF(Y1.LT.YMIN.AND.Y2.GT.YMIN.AND.Y2.LT.YMAX)THEN
      AMM=(Y2-Y1)/(X-XOLD)
      ANN=Y2-AMM*X
      Y1=YMIN
      XOLD=(YMIN-ANN)/AMM
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ELSEIF(Y2.LT.YMIN.AND.Y1.GT.YMIN.AND.Y1.LT.YMAX)THEN
      AMM=(Y2-Y1)/(X-XOLD)
      ANN=Y2-AMM*X
      Y2=YMIN
      X=(YMIN-ANN)/AMM
      WRITE(IMF,101)XOLD,0.1*YMM+(Y1-
     *YMIN)*YSCALE,X,0.1*YMM+(Y2-
     *YMIN)*YSCALE
      ENDIF
      Y1=Y2
      XOLD=X
15    CONTINUE
      YOLD(JJ)=Y1
4     CONTINUE
      X3=X
      IORIG=0
      ENDIF
3     CONTINUE
      XOLD=(XLSPC1+XLSPC)*XMM
      X=XOLD
      XSCALE=XMMEFF/WW
      IF(IFERMI.NE.0)THEN
      IF((COSXY.GT.YMIN).AND.(COSXY.LT.YMAX))THEN
      EFERMI=0.1*YMM+(COSXY-YMIN)*YSCALE
      DO 5 I=1,ISEGA
      IF(W(I).EQ.0.0)THEN
      WRITE(IMF,101)XOLD,EFERMI,X,EFERMI
      X=X+WINTER*XMM
      XOLD=X
      ELSE
      X=X+W(I)*XSCALE
      ENDIF
5     CONTINUE
      WRITE(IMF,101)XMM*(1.-RSPC),EFERMI,
     *XMM*(1.-RSPC+XLTICK),EFERMI
C     WRITE(IMF,104)XMM*(1.-RSPC+2.*XLTICK),EFERMI,'Ef'
      WRITE(IMF,108)XMM,EFERMI,'Ef'
      ENDIF
      ENDIF
6     WRITE(IMF,101)(XLSPC1+XLSPC-XLTICK)*XMM,
     *0.1*YMM+
     *(RL-YMIN)*YSCALE,(XLSPC1+XLSPC)*XMM,
     *0.1*YMM+(RL-YMIN)*YSCALE
      WRITE(IMF,105)(XLSPC1+XLSPC-2.*XLTICK)*XMM,
     *0.1*YMM+(RL-YMIN)*YSCALE,RL
      RL=RL+RS
      IF(RL.LE.(RU+1E-4).OR.RL.LE.(RU-1E-4))GOTO 6
      WRITE(IMF,103)(XLSPC1+XLSPC)*XMM+(XMMEFF*0.5),0.0,DLABEL
c     WRITE(IMF,103)2.*(XLSPC1+XLSPC)*XMM+(XMMEFF*0.5),0.0,DLABEL
      WRITE(IMF,106)0.0,0.1*YMM+(YMMEFF*0.5),LLABEL
      RETURN
100   FORMAT(A4)
101   FORMAT('LINE',4F10.2)
102   FORMAT('LINT',2F10.2)
103   FORMAT('STCB',2F10.2,1X,50A)
104   FORMAT('STLC',2F10.2,1X,50A)
105   FORMAT('STRC',2F10.2,1X,F9.2)
106   FORMAT('STDU',2F10.2,1X,50A)
107   FORMAT('CHAR',F10.2)
108   FORMAT('STRC',2F10.2,1X,50A)
111   FORMAT('COOR',2F10.2)
      END
      SUBROUTINE RPLOT(IIN,RMAT)
      CHARACTER*4 TY
      DIMENSION RMAT(*)
      COMMON /RPL/NROW,NCOL,X0,Y0,DX,DY,COSXY
      IOUT=6
      READ(IIN,200,END=999)MARK,TY,NROW,NCOL,DX,DY,COSXY
      READ(IIN,260)X0,Y0
      READ(IIN,251)IC1,IC2,IC3,IC4,IC5,IC6
      NELEM=NROW*NCOL
      WRITE(IOUT ,250)MARK,TY,IC1,IC2,IC3,IC4,IC5,IC6
      READ (IIN,220)(RMAT(J),J=1,NELEM)
      RETURN
999   PRINT *,'END OF DATA IN FORTRAN UNIT ',IIN
200   FORMAT(3X,I1,A4,2I5,1P,(3E12.5))
251   FORMAT(6I5)
260   FORMAT(6(1PE12.5))
250   FORMAT(1X,I1,2X,A4,2X,6I5)
220   FORMAT(6(1PE12.5))
      STOP
      END
