C     *****************************************************
C
C                    CrGraph Package V2.0
C                       DOSS Program
C
C      Theoretical Chemistry Group - University of Torino
C      Adapted by Ales Zupan - University of Lubiana
C
C     *****************************************************
      PROGRAM DOSS
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /FILES/IPLOT,ISCR,IMF,IUHF,IFERMI
      COMMON /CONT/XMM,YMM,UOFF,RL,RU,RS,DLBL,DEFER,DNUM,
     *             XLTICK,DMAX,DMIN,XMIN,XMAX,XPOS,YPOS
      COMMON /RPL/X0,Y0,DX,DY,ENEFE,RMUL(20),NROW,NCOL
      CHARACTER*30 LBL(20),DLABEL
      IPLOT=25
      ISCR=19
      IOUT=6
      IMF=18
      WRITE(*,100) 'DOSS program'
      WRITE(*,100) 'Extracting file'
      CALL EXTRACT(ISEG)
      CALL INIT(ISEG,LBL,DLABEL)
      WRITE(IOUT,101)DMIN,DMAX
101   FORMAT(' DOSS MINIMUM AND MAXIMUM VALUE',1P2E12.4)
      WRITE(*,100) 'Creating metafile'
      CALL MAKEMF(ISEG,LBL,DLABEL)
100   FORMAT(1X,80A)
      END
      SUBROUTINE DASH(X0,Y0,X1,Y1,Q0,III,KKK,IPP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION T(6,4),M(4)
      DATA T/4.0D0,2.0D0,4*0.D0,3.0D0,1.50D0,.500D0,
     *1.50D0,2*0.D0,0.50D0,1.0D0,4*5.0D0,
     *3.0D0,2.0D0,0.50D0,1.50D0,0.50D0,2.0D0/
C     DATA T/0.1D0,0.2D0,4*0.D0,0.3D0,0.15D0,0.05D0,
C    *0.15D0,2*0.D0,0.05D0,0.1D0,4*0.5D0,
C    *0.3D0,0.2D0,0.05D0,0.15D0,0.05D0,0.2D0/
      DATA M/2,4,2,6/
      DELTA=DSQRT((X1-X0)**2+(Y1-Y0)**2)
      IF(DELTA.LT.1.D-06)DELTA=1.D-06
      UX=(X1-X0)/DELTA
      IND=0
      UY=(Y1-Y0)/DELTA
1     Q=Q0+T(III,KKK)
      IF(Q.LT.DELTA)GO TO 2
      IND=1
      Q=DELTA
      Q0=Q0-DELTA
2     X=X0+Q*UX
      Y=Y0+Q*UY
      ISIGN=(III/2)*2-III+3
      IF(IPP.EQ.3)  ISIGN=3
      CALL ZPLOT(X,Y,ISIGN)
      IF(IND.EQ.1)RETURN
      III=III+1
      Q0=Q
      IF(III.LE.M(KKK))GO TO 1
      III=1
      GO TO 1
      END
      SUBROUTINE EXTRACT(ISEG)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /FILES/IPLOT,ISCR,IMF,IUHF,IFERMI
      COMMON /CONT/XMM,YMM,UOFF,RL,RU,RS,DLBL,DEFER,DNUM,
     *             XLTICK,DMAX,DMIN,XMIN,XMAX,XPOS,YPOS
      COMMON /RPL/X0,Y0,DX,DY,ENEFE,RMUL(20),NROW,NCOL
      DIMENSION RMAT(10000)
      CHARACTER*4 TY
      ISEG=0
      DMAX=0.0D0
      DMIN=DMAX
10    READ(IPLOT,200,END=999)MARK,TY,NRDU,NCDU,DXDU,DYDU,COSXY
      NELEM=NRDU*NCDU
      IF (TY.EQ.'DOSS') THEN
      ENEFE=COSXY
      NROW=NRDU
      NCOL=NCDU
      DX=DXDU
      DY=DYDU
      READ(IPLOT,260)X0,Y0
      READ(IPLOT,250,END=999)IC1,IC2,IC3,IC4,IC5,IC6
      ISEG=ISEG+1
      WRITE(ISCR,200)MARK,TY,NROW,NCOL,DX,DY,COSXY
      WRITE(ISCR,260)X0,Y0
      WRITE(ISCR,250)IC1,IC2,IC3,IC4,IC5,IC6
      XMIN=Y0
      XMAX=Y0+(NCOL-1.D0)*DY
      IF(MARK.GT.1)IFERMI=1
      IUHF=MOD(MARK,2)
      READ(IPLOT,260) (RMAT(J),J=1,NELEM)
      DO j=1,nelem
      DMAX=MAX(DMAX,RMAT(j))
      DMIN=MIN(DMIN,rmat(j))
      enddo
      WRITE(ISCR,260) (RMAT(J),J=1,NELEM)
      ELSE
      READ(IPLOT,200)IDUM
      READ(IPLOT,221)NADUM
      READ(IPLOT,260) (RJUNK,J=1,NELEM)
      IF(TY.EQ.'MAPN') THEN
      DO II=1,nadum
      read(iplot,250)idum
      enddo
      read(iplot,110)(adum,i=1,9)
110   FORMAT(3E20.12)
      endif
      ENDIF
      GOTO 10
999   WRITE(*,210)ISEG
      IF(ISEG.EQ.0)STOP
      ISEG=ISEG/(IUHF+1)
      REWIND IPLOT
      REWIND ISCR
      RETURN
200   FORMAT(3x,I1,A4,2I5,1P,(3E12.5))
210   FORMAT(' DOSS DATA - ',I2,' PROJECTION(S)')
221   FORMAT(40X,I4)
250   FORMAT(6I5)
260   FORMAT(6(1PE12.5))
      END
      SUBROUTINE INIT(ISEG,LBL,DLABEL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*30 DLABEL,LBL(20)
      COMMON /FILES/IPLOT,ISCR,IMF,IUHF,IFERMI
      COMMON /CONT/XMM,YMM,UOFF,RL,RU,RS,DLBL,DEFER,DNUM,
     *             XLTICK,DMAX,DMIN,XMIN,XMAX,XPOS,YPOS
      COMMON /XMINMAX/XXMIN,XXMAX
      COMMON /RPL/X0,Y0,DX,DY,ENEFE,RMUL(20),NROW,NCOL
      DATA A4W,A4H/180.D0,270.D0/
      IIN=5
      READ(IIN,*)XMM,YMM
      IF(XMM.GT.A4W)THEN
      WRITE(*,102)XMM,A4W
      XMM=A4W
      ENDIF
      IF(YMM.GT.A4H)THEN
      WRITE(*,103)YMM,A4H
      YMM=A4H
      ENDIF
      READ(IIN,*)XXMIN,XXMAX,RS
      RU=XXMAX
      RL=NINT(XXMIN/RS)
      RL=RL*RS+RS
      READ(IIN,*)XPOS,YPOS
      READ(IIN,100) DLABEL
      DO 1 I=1,ISEG
      READ(IIN,*) RMUL(I)
      READ(IIN,100)LBL(I)
1     CONTINUE
      DNUM=0.05D0
      DEFER=0.05D0
      DLBL=0.05D0
C *** UOFF scaling of maximum doss value in the frame
c     UOFF=0.005D0
      UOFF=0.02D0
      XLTICK=0.02D0
      RETURN
100   FORMAT(A30)
102   FORMAT(' WIDTH ',F7.1,' REDUCED TO A4',F7.1)
103   FORMAT(' HEIGTH',F7.1,' REDUCED TO A4',F7.1)
      END
      SUBROUTINE LINEA(N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER(NNMAX=400)
      COMMON  /DOSLIN/XX(NNMAX),YY(NNMAX)
      X1=XX(1)
      Y1=YY(1)
      CALL ZPLOT(X1,Y1,3)
      DO 3 I=2,N
      IPP=2
      X2=XX(I)
      Y2=YY(I)
C ***
C ***  CHECK DELLA MASCHERATURA
C ***
      CALL ZPLOT(X2,Y2,IPP)
3     CONTINUE
      RETURN
      END
      SUBROUTINE MAKEMF(ISEG,LBL,DLABEL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /FILES/IPLOT,ISCR,IMF,IUHF,IFERMI
      COMMON /CONT/XMM,YMM,UOFF,RL,RU,RS,DLBL,DEFER,DNUM,
     *             XLTICK,DMAX,DMIN,XMIN,XMAX,XPOS,YPOS
      COMMON /RPL/X0,Y0,DX,DY,ENEFE,RMUL(20),NROW,NCOL
      COMMON /XMINMAX/XXMIN,XXMAX
      PARAMETER(NNMAX=400)
      COMMON  /DOSLIN/XX(NNMAX),YY(NNMAX)
      DIMENSION RMAT(10000)
      CHARACTER*4 TY
      CHARACTER*30 DLABEL,LBL(20),AUXLBL
      WRITE(IMF,111) XMM,YMM
      WRITE(IMF,112) 0.7*DNUM*YMM
      XMMEFF=XMM
      YMMEFF=YMM*(1.-DNUM-DEFER-DLBL)
      WW=1.D0/(ISEG+1*IUHF)
      WRITE(IMF,101) 0.,(DNUM+DEFER+DLBL)*YMM,XMM,
     *(DNUM+DEFER+DLBL)*YMM
      WRITE(IMF,101) 0.,(DNUM+DEFER+DLBL)*YMM,0.,YMM
      WRITE(IMF,101) XMM,(DNUM+DEFER+DLBL)*YMM,XMM,YMM
      YSCALE=YMMEFF*WW
      Y=(DNUM+DEFER+DLBL)*YMM
      y=y+yscale*iuhf
      if(iuhf.ne.0)WRITE(IMF,101) 0.0,Y,XMM,Y
      DO 2 I=1,ISEG
      WRITE(IMF,107) XPOS*XMM,Y+YPOS*YSCALE,LBL(I)
      IF (RMUL(I).NE.1.0) THEN
      WRITE(AUXLBL,121) RMUL(I)
      J=0
11    J=J+1
      IF ((AUXLBL(J:J).EQ.' ').AND.(J.LE.30)) GOTO 11
      WRITE(IMF,107) (XPOS+0.09)*XMM,Y+YPOS*YSCALE,' X ',
     *                     AUXLBL(J:30)
      ENDIF
      Y=Y+YSCALE
      WRITE(IMF,101) 0.0,Y,XMM,Y
2     CONTINUE
      IF (XMIN.LT.XXMIN) THEN
      DO 123 J=1,NCOL
      XVAL=XMIN+(J-1)*DY
      IF(XVAL.GE.XXMIN) THEN
      NCINZ=J
      GOTO 124
      ENDIF
123   CONTINUE
124   CONTINUE
      ELSEIF (XMIN.GE.XXMIN) THEN
      NCINZ=1
      ENDIF
      XSCALE=XMMEFF/(XXMAX-XXMIN)
      DO 3 II=1,IUHF+1
      YOLD=(DNUM+DEFER+DLBL)*YMM+yscale*iuhf
      DO 3 I=1,ISEG
      CALL RPLOT(ISCR,TY,RMAT,NR,NC,X0R,X0C,DXR,DXC,
     *                 CFI,IC1,IC2,IC3,IC4,IC5,IC6)
      YSCALE1=((YMMEFF*WW)-UOFF*YMM)/DMAX*RMUL(I)
      XVAL=XMIN+(NCINZ-1)*DY
      XX(1)=(XVAL-XXMIN)*XSCALE
      YY(1)=YOLD+RMAT(NCINZ+1)*YSCALE1
      N=1
      DO 4 J=NCINZ+2,NCOL
      N=N+1
      XVAL=XMIN+(J-1)*DY
      IF (XVAL.GT.XXMAX) GOTO 1688
      XX(N)=(XVAL-XXMIN)*XSCALE
      YY(N)=YOLD+RMAT(J)*YSCALE1
4     CONTINUE
1688  N=N-1
      YOLD=YOLD+YSCALE
      IF(II.EQ.1) THEN
      CALL LINEA(N)
      ELSE
      CALL TRATTO(N,3)
      ENDIF
3     CONTINUE
      XSCALE=XMMEFF/(XXMAX-XXMIN)
      IF(IFERMI.NE.0)THEN
      IF ((ENEFE.GT.XXMIN).AND.(ENEFE.LT.XXMAX)) THEN
      EFERMI=(ENEFE+2.D-3-XXMIN)*XSCALE
      WRITE(IMF,101) EFERMI,(DNUM+DEFER+DLBL)*YMM,EFERMI,YMM
      WRITE(IMF,103) EFERMI,DLBL*YMM,'Ef'
      ENDIF
      ENDIF
6     CONTINUE
      IF(RL.GE.XXMIN.OR.RL.LE.XXMAX) THEN
      WRITE(IMF,101) (RL-XXMIN)*XSCALE,
     *               (DNUM+DEFER+DLBL)*YMM,
     *               (RL-XXMIN)*XSCALE,
     *               (DNUM+DEFER+DLBL+XLTICK)*YMM
      WRITE(IMF,101) (RL-XXMIN)*XSCALE,YMM,
     *               (RL-XXMIN)*XSCALE,YMM-XLTICK*YMM
      WRITE(AUXLBL,121) RL
      J=0
12    J=J+1
      IF ((AUXLBL(J:J).EQ.' ').AND.(J.LE.30)) GOTO 12
      WRITE(IMF,103) (RL-XXMIN)*XSCALE,
     *               (DLBL+DEFER)*YMM,AUXLBL(J:30)
      ENDIF
      RL=RL+RS
      IF (RL.LE.(RU+1.E-4).OR.RL.LE.(RU-1.E-4)) GOTO 6
      WRITE(IMF,103) (XMMEFF/2.0),0.0,DLABEL
      RETURN
101   FORMAT('LINE',4F10.2)
102   FORMAT('LINT',2F10.2)
103   FORMAT('STCB',2F10.2,1X,30A)
104   FORMAT('STLC',2F10.2,1X,30A)
105   FORMAT('STRC',2F10.2,1X,F5.2)
106   FORMAT('STDU',2F10.2,1X,30A)
107   FORMAT('STLB',2F10.2,1X,30A)
111   FORMAT('COOR',2F10.2)
112   FORMAT('CHAR',F10.2)
121   FORMAT(F10.2)
      END
      SUBROUTINE RPLOT(IPLOT,TY,RMAT,NR,NC,X0,Y0,DX,DY,
     *                 COSXY,IC1,IC2,IC3,IC4,IC5,IC6)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*4 TY
      DIMENSION RMAT(10000)
      IOUT=6
      READ(IPLOT,200,END=999)MARK,TY,NR,NC,DX,DY,COSXY
      READ(IPLOT,260)X0,Y0
      READ(IPLOT,251)IC1,IC2,IC3,IC4,IC5,IC6
      NELEM=NR*NC
      WRITE(IOUT,250)MARK,TY,IC1,IC2,IC3,IC4,IC5,IC6
      READ (IPLOT,260)(RMAT(J),J=1,NELEM)
      RETURN
200   FORMAT(3X,I1,A4,2I5,1P,(3E12.5))
251   FORMAT(6I5)
260   FORMAT(6(1PE12.5))
250   FORMAT(1X,I1,2X,A4,2X,6I5)
999   WRITE(IOUT,252)
252   FORMAT(' END OF DOSS DATA ON SCRATCH UNIT')
      STOP
      END
      SUBROUTINE TRATTO(N,KKK)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER(NNMAX=400)
      COMMON  /DOSLIN/XX(NNMAX),YY(NNMAX)
      X0=XX(1)
      Y0=YY(1)
      CALL ZPLOT(X0,Y0,3)
      III=1
      Q0=0.D0
      DO 3 I=2,N
      IPP=2
      X1=XX(I)
      Y1=YY(I)
C ****
C ****  CHECK DELLA MASCHERATURA
C ****
      CALL DASH(X0,Y0,X1,Y1,Q0,III,KKK,IPP)
      X0=X1
      Y0=Y1
3     CONTINUE
      RETURN
      END
      SUBROUTINE ZPLOT(X,Y,IMODO)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /LINE/ XOLD,YOLD,ISTAT
      COMMON /OFF/ XOFF
      IF (IMODO.EQ.-3) THEN
      WRITE(18,200)'COOR',X,Y
      RETURN
      ENDIF
      X0=XOFF+X
      Y0=Y
      IF (IMODO.EQ.3) THEN
      XOLD=X0
      YOLD=Y0
      ISTAT=1
      ELSEIF (IMODO.EQ.2) THEN
      IF (ISTAT.EQ.1) THEN
      ISTAT=0
      WRITE(18,200) 'LINE',XOLD,YOLD,X0,Y0
      ELSE
      WRITE(18,200) 'LINT',X0,Y0
      ENDIF
      ENDIF
200   FORMAT(A4,4F10.2)
      RETURN
      END
