C     *****************************************************
C
C                    CrGraph Package V2.0
C                       ECH3IN program
C      Input: formatted data generated with ECH3 keyword ft17
C      Output:formatted data written with CUBE scheme (Gaussian98)
C
C      Theoretical Chemistry Group - University of Torino
C
C     *****************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MATDIM=100000)
      DIMENSION RMAT(MATDIM)
      IPLOT=25
      ISCR=31
      ISCRou=17
      IOUT=6
      read(iscr,99,end=999)tit
      READ(iscr,*,end=999)npa,npb,npc       
      ntot=npa*npb*npc
      write(iout,199)tit,ntot,npa,npb,npc
      write(iscrou,199)tit,ntot,npa,npb,npc
      natoms=0
      if(ntot.gt.matdim)then
      write(iout,110)ntot,matdim
110   format(' stop - input data:;',i6,' max dim',i6)
      stop
      endif
c     ech3 loop order    g98 loop order  
c     external (Npc)         N1        
c     intermediate  (NPB)    N2       
c     inner   (NPA)          N3      
      read(iscr,*,end=999)x0,y0,z0
      read(iscr,*,end=999)dxa,dya,dza
      read(iscr,*,end=999)dxb,dyb,dzb
      read(iscr,*,end=999)dxc,dyc,dzc
      write(iscrou,111)natoms,x0,y0,z0
      write(iscrou,111)npc,dxc,dyc,dzc
      write(iscrou,111)npb,dxb,dyb,dzb
      write(iscrou,111)npa,dxa,dya,dza
      read(iscr,106,end=999)(rmat(ind),ind=1,ntot)
      iniz=1
      ifin=npa
      do 2 nc=1,npc
      do 2 nb=1,npb
      write(iscrou,105)(rmat(i),i=iniz,ifin)
      iniz=ifin+1
      ifin=ifin+npa
2     continue
      rewind iscrou
      rewind iscr
      stop
99    format(a80)
199   format(' ECH3 data',a60/' Tot ',i5,'(',i3,',',i3,',',i3,')')
100   format(i4,f7.3,1p,3e16.8)
104   format(1p,6e12.5)
105   format(6e13.5)
106   format(5f15.6)
107   format(' stop - end of ech3 data')
111   format(I5,3f12.6)
999   write(iout,107)
      stop
      end
