C     *****************************************************
C
C                    CrGraph Package V2.0
C                       G98INP program
C      Input: formatted data generated with CUBE keyword ft19
C      Output:formatted data for plotting in fortran unit 25
C
C      Theoretical Chemistry Group - University of Torino
C
C     *****************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      character*80 tit
      logical inbox
      PARAMETER (MATDIM=10000,lim016=10000)
      DIMENSION RMAT(MATDIM),nat(lim016),xa(3,lim016),qat(lim016)
      dimension x1(3),x2(3),xv(3),xt(3),y2(3),xp(3)
      COMMON /FILES/IPLOT,ISCR
      CHARACTER*2 SYMBAT(0:92)
      DATA SYMBAT/   'XX','H ','HE','LI','BE','B ','C ','N ',
     1'O ','F ','NE','NA','MG','AL','SI','P ','S ','CL','AR',
     2'K ','CA','SC','TI','V ','CR','MN','FE','CO','NI','CU',
     3'ZN','GA','GE','AS','SE','BR','KR','RB','SR','Y ','ZR',
     4'NB','MO','TC','RU','RH','PD','AG','CD','IN','SN','SB',
     5'TE','I ','XE','CS','BA','LA','CE','PR','ND','PM','SM',
     6'EU','GD','TB','DY','HO','ER','TM','YB','LU','HF','TA',
     7'W ','RE','OS','IR','PT','AU','HG','TL','PB','BI','PO',
     8'AT','RN','FR','RA','AC','TH','PA','U '/
      IPLOT=25
      ISCR=17
      IOUT=6
      confac=0.529177249D0
      ldim=0
      read(iscr,99,end=999)tit
      write(iout,99)tit
      read(iscr,99,end=999)tit
      write(iout,99)tit
      READ(iscr,*,end=999)Natoms,xb,yb,zb
c     g98 loop order       maps loop order:
c     external (N1)            plane         
c     intermediate  (N2)      number of column - BC segment
c     inner   (N3)            number of row - AB segment
      read(iscr,*,end=999)nmap,dx1,dy1,dz1
      read(iscr,*,end=999)ncol,dx2,dy2,dz2
      read(iscr,*,end=999)nrow,dx3,dy3,dz3
      ndat=ncol*nrow
      DBC=sqrt(dx2**2+dy2**2+dz2**2)
      BC=DBC*(ncol-1)
      DAB=sqrt(dx3**2+dy3**2+dz3**2)
      AB=DAB*(nrow-1)
      COSANG=(dx2*dx3+dy2*dy3+dz2*dz3)/(DAB*DBC)
      ang=acos(cosang)
      write(iout,101)natoms,nmap,nrow,ncol,ndat,AB,BC,COSANG
      do 1 na=1,natoms
      read(iscr,*,end=999)nat(na),qat(na),xa(1,na),xa(2,na),xa(3,na) 
      write(iout,100)nat(na),qat(na),xa(1,na),xa(2,na),xa(3,na)
1     continue
      do 2 nplan=1,nmap
      write(iplot,102)nrow,ncol,DAB,DBC,COSANG
      write(iout,103)nplan,xb,yb,zb
      ind=0
      xaa=xb+dx2*(nrow-1)
      yaa=yb+dy2*(nrow-1)
      zaa=zb+dz2*(nrow-1)
      xc=xb+dx3*(ncol-1)
      yc=yb+dy3*(ncol-1)
      zc=zb+dz3*(ncol-1)
      write(iout,106)xaa,yaa,zaa,xb,yb,zb,xc,yc,zc
      WRITE(IPLOT,221)XAA*CONFAC,YAA*CONFAC,ZAA*CONFAC,XB*CONFAC,
     *YB*CONFAC,ZB*CONFAC,XC*CONFAC,YC*CONFAC,ZC*CONFAC,natoms,ldim
      ind=0
      do 3 nc=1,ncol
      read(iscr,105)(rmat(ind+nr),nr=1,nrow)
      ind=ind+nrow
3     continue
      xb=xb+dx1
      yb=yb+dy1
      zb=zb+dz1
      write(iplot,104)(rmat(i),i=1,ndat)
      do na=1,natoms
      write(iplot,1062)nat(na),SYMBAT(nat(NA)),(xa(K,na),K=1,3)
      enddo
      write(iplot,110)500.,0.,0.,0.,500.,0.,0.,0.,500.
110   FORMAT(3E20.12)
2     continue
      rewind iplot
      rewind iscr
99    format(a80)
100   format(i4,f7.3,1p,3e16.8)
101   format(' data from gaussian98'//' atoms',i4,' planes (N1)',i3/
     *' grid points on each plane',i4,'(N3) x',i4,'(N2) (',i4,')'/
     *' size of the map ',f8.3,'(AB) x',f8.3,'(BC) a.u.'/
     *' cos angle ab bc',f8.4// ' atoms coordinates (a.u.)') 
102   format('-%-0MAPN',2i4,1p,3e12.5)
103   format(' MAP N.',I3/' COORDINATES OF G98 POINT (0,0)'/1P,3E16.8)
104   format(1p,6e12.5)
105   format(6e13.5)
221   FORMAT(1P,6E12.5/3E12.5,4X,I4)
106   format(' CRGRAPH COORDINATES:',4X,'X',12X,'Y',12X,'Z'/
     *17X,'A',1P,3E13.5/17X,'B',3E13.5/17X,'C',3E13.5)
107   format(' stop - end of gaussian 98 data')
1062  FORMAT(I4,1X,A,1P,3E20.12)
      stop
999   write(iout,107)
      end
