C     *****************************************************
C
C                    CrGraph Package V2.0
C                       MAPS Program
C
C      Theoretical Chemistry Group - University of Torino
C      Adapted by Ales Zupan - University of Lubiana
C
C     *****************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*4 TY
      character*2 symbat
      CHARACTER*40 ROUTE(0:5)
      logical repeat
      parameter (lim016=10000)
      COMMON /PIVR/ZETA,DEZETA,J1,J2,I1,I2,KI,NI,KP,NP,DIV,
     *  EX,DX,DY,NX,NY
      PARAMETER(NPP1=500,NNMAX=NPP1*NPP1,NNMA2=NNMAX+2,NLIMAX=500,
     *MAPMAX=100)
      PARAMETER(NLIN=10,NLIPOT=NLIN*2+1,NLDIF=31,NCTR1=13,
     *NCTPOT=NCTR1*2+1,NCTR1DIF=31)
      DIMENSION RMAT(NNMAX),ZLIV(NLIMAX),IPOT(MAPMAX)
      COMMON /ISOLIN/ XX(NNMA2),YY(NNMA2),X(NPP1),Y(NPP1),A(NPP1,NPP1),
     *      IP(NNMAX/2),JP(NNMAX/2)
      COMMON /ROMB/ COSF,SINF
      COMMON /LINE/ XOLD,YOLD,ISTAT
      COMMON /OFF/ XOFF
      common/atomi/paret(3,3),xa(3,lim016),nat(lim016),NAF,LDIM
      common/symbat/symbat(lim016)
      COMMON /FILES/IPLOT,ISCR,IMF,IUHF,IFERMI,IIN,IOUT
      common /framedat/XAA,YAA,ZAA,XB,YB,ZB,XC,YC,ZC
      DIMENSION Xg(3,lim016)
      dimension x1(3),x2(3),xv(3),y2(3),xt(3),xp(3)
      DIMENSION CTR1(NCTR1),CTR1DIF(NCTR1DIF),CLN(NLIN),CLNDIF(NLDIF),
     *CLNPOT(NLIPOT),CTRPOT(NCTPOT)
      DATA CTR1/.002D0,.004D0,.008D0,.02D0,.04D0,.08D0,.2D0,.4D0,.8D0,
     *2.D0,4.D0,8.D0,20.D0/
      DATA CTRPOT/-20.D0,-8.D0,-4.D0,-2.D0,-.8D0,-.4D0,-.2D0,-.08D0,
     *-.04D0,-.02D0,-.008D0,-.004D0,-.002D0,0.D0,002D0,.004D0,.008D0,
     *.02D0,.04D0,.08D0,.2D0,.4D0,.8D0,2.D0,4.D0,8.D0,20.D0/
      DATA CTR1DIF/0.D0,.0002D0,-.0002D0,.0004D0,-.0004D0,.0008D0,
     *-.0008D0,.002D0,-.002D0,.004D0,-.004D0,.008D0,-.008D0,.02D0,
     *-.02D0,.04D0,-.04D0,.08D0,-.08D0,.2D0,-.2D0,.4D0,-.4D0,.8D0,
     *-.8D0,2.D0,-2.D0,4.D0,-4.D0,8.D0,-8.D0/
      DATA CLN/0.01D0,0.02D0,0.03D0,0.04D0,0.05D0,0.06D0,0.07D0,
     *0.08D0,0.09D0,0.1D0/
      DATA CLNPOT/-.1D0,-.09D0,-.08D0,-.07D0,-.06D0,-.05D0,-.04D0,
     *-.03D0,-.02D0,-.01D0,0.D0,.01D0,.02D0,.03D0,.04D0,.05D0,.06D0,
     *.07D0,.08D0,.09D0,0.1D0/
      DATA CLNDIF/-0.015D0,-0.014D0,-0.013D0,-0.012D0,-0.011D0,-0.010D0,
     *-0.009D0,   -0.008D0,-0.007D0,-0.006D0,-0.005D0,-0.004D0,-0.003D0,
     *-0.002D0,-0.001D0,-0.0D0,0.001D0,0.002D0,0.003D0,0.004D0,0.005D0,0
     *.006D0,0.007D0,0.008D0,0.009D0,0.01D0,0.011D0,0.012D0,0.013D0,0.01
     C4D0,0.015D0/
      DATA A4W,A4H/180.D0,270.D0/
      data route/'total - default linear scale',
     *           'difference - default linear scale',
     *           'total - default logaritmic scale',
     *           'difference - default logaritmic scale',
     *           'user defined scale',
     *           'user defined scale'/
C
C       NL      NUMBER OF CONTOUR LINES
C       XL,YL   DIMENSION OF THE PICTURE
C       ZETA    MINIMUM VALUE OF THE FUNCTION
C       DEZETA  INCREMENT OF THE FUNCTION
C       ZMAX    MAXIMUM VALUE OF THE FUNCTION
C
      IIN=5
      IOUT=6
      ISCR=19
      IPLOT=25
      IMF=18
      iat2d=1
      tolzer=0.5D0
      tolbox=1.D-2
      repeat=.false.
C *** INPUT DATA TO BE PLOTTED ARE READ FROM FORTRAN UNIT 25
      WRITE(IOUT,114) 
114   format(' Map program'/' Written by Mauro Causa, Universita di',
     *' Torino'/'Adapted by Ales ZUPAN, IJS, Slovenia '//)
      CALL EXTRACT(RMAT,IPOT)
      NP=NNMAX
      NI=NNMAX
      EX=1D-7
      IMAP=1
      icount=1
10    CONTINUE
C ***
C *** INPUT CONTROL PARAMETERS FROM FORTRAN UNIT 5
C *** AXISMM HEIGHT(mm) OF THE MAP ON A4 SHEET PORTRAIT MODE
C ***
      READ(IIN,*,END=999)AXISMM,IROUTE,IDRAW,ICOL
CBI   
C ***  IDRAW VALUES
C ***   0  no label
C ***   1  label
C ***   2  label+stick 
C ***   3  balls+spokes+label
C ***   4  vdW+label
C ***  ICOL: 0 = b/w , 1 = color 
CBF
      AXISAV=AXISMM
      IRSAVE=IROUTE
C ***
C ***  IROUTE  VALUES
C ***                  linear scale   log scale   input scale
C *** total map            0             2             4
C *** difference map       1             3             5
C *** NMODE (mod(iroute,2) = 0 TOTAL  map (1 set of data on fort.25)
C ***                      = 1 difference (2 sets of data on fort.25)
C *** ISCALE (iroute/2)    = 0 linear scale
C ***                      = 1 log scale
C ***                      = 2 input scale
C ***
40    IF(IROUTE.LT.0.OR.IROUTE.GT.5)THEN
      PRINT *,'IROUTE VALUE NOT ALLOWED',IROUTE
      STOP
      ENDIF
      WRITE(IOUT,110)ROUTE(IROUTE)
      NMODE=MOD(IROUTE,2)
      ISCALE=IROUTE/2
      IF(ABS(AXISMM).GT.A4H)THEN
      WRITE(IOUT,105)AXISMM
      AXISMM=A4H-40
      ENDIF
C *** LINEAR SCALE
      IF(ISCALE.EQ.0)THEN
      IF(NMODE.NE.0)THEN
      NL=NLDIF
      ZLIV(1:NL)=CLNDIF(1:NL)
      ZETA=ZLIV(1)
      ZMAX=ZLIV(NL)
      ELSE
      IF(IPOT(IMAP).NE.0)THEN
      NL=NLIPOT
      ZLIV(1:NL)=CLNPOT(1:NL)
      ZETA=ZLIV(1)
      ZMAX=ZLIV(NL)
      ELSE
      NL=NLIN
      ZLIV(1:NL)=CLN(1:NL)
      ZETA=ZLIV(1)
      ZMAX=ZLIV(NL)
      ENDIF
      ENDIF
C *** LOGARITMIC SCALE
      ELSEIF(ISCALE.EQ.1)THEN
      IF(NMODE.NE.0)THEN
      NL=NCTR1DIF
      ZLIV(1:NL)=CTR1DIF(1:NL)
      ZETA=ZLIV(1)
      ZMAX=ZLIV(NL)
      ELSE
      IF(IPOT(IMAP).NE.0)THEN
      NL=NCTPOT
      ZLIV(1:NL)=CTRPOT(1:NL)
      ZETA=ZLIV(1)
      ZMAX=ZLIV(NL)
      ELSE
      NL=NCTR1
      ZLIV(1:NL)=CTR1(1:NL)
      ZETA=ZLIV(1)
      ZMAX=ZLIV(NL)
      ENDIF
      ENDIF
C *** INPUT DEFINED SCALE
      ELSEIF(ISCALE.EQ.2)THEN
C *** ZETA MINIMUM VALUE - IT CAN BE NEGATIVE
C *** ZMAX MAXIMUM VALUE
C *** DEZETA INCREMENT
      IUHSAV=IUHF
      IUHF=0
      if(repeat)then
      zeta=zetasav
      zmax=zmaxsav
      dezeta=dezetasav
      else
      READ(IIN,*,end=998) ZETA,ZMAX,DEZETA
      zetasav=zeta
      zmaxsav=zmax
      dezetasav=dezeta
      endif
      NL=NINT((ZMAX-ZETA)/DEZETA)+1
      IF(NL.GT.NLIMAX)THEN
      PRINT *,' TOO MANY LEVELS (',NL,') - INCREASE NLIMAX'
      STOP
      ENDIF
      ZLIV(1)=ZETA
      DO I=2,NL
      ZLIV(I)=ZLIV(I-1)+DEZETA
      ENDDO
      ENDIF
C ****
C **** NY   = NUMBER OF POINTS ON Y AXIS (ROW INDEX)
C **** NX   = NUMBER OF POINTS ON X AXIS (COLUMN INDEX)
C **** ADX  = STEP ON X AXIS
C **** ADY  = STEP ON Y AXIS
C **** COSF = COSINE OF THE ANGLE BETWEEN THE TWO DIRECTIONS X,Y
      DO 333 ILOOP=0,IUHF
      IF(NMODE.NE.0.AND.IUHF.NE.0)THEN
      IF(ILOOP.NE.0)CALL SKIPBW(ISCR,2,NELEM)
      ENDIF
      WRITE(IOUT,100)icount
      CALL RMAPLO(iloop,ISCR,TY,RMAT,NY,NX,ADY,ADX,COSF)
      icount=icount+1
      if(ny*nx.eq.0)goto 10
      IF(IMAP.GT.1)WRITE(IMF,101)'NEWP'
      IMAP=IMAP+1
      NELEM=NX*NY
      IF(NELEM.GT.NNMAX) THEN
      AA=NELEM
      PRINT *,' INCREASE NPP1 TO ',SQRT(AA)
      STOP
      ENDIF
      IF(NX.GT.NPP1.OR.NY.GT.NPP1) THEN
      IIII=MAX(NX,NY)
      PRINT *,' INCREASE NPP1 TO ',IIII
      STOP
      ENDIF
      IND=0
      DO 2 IX=1,NX
      DO 2 IY=NY,1,-1
      IND=IND+1
2     A(IX,IY)=RMAT(IND)
      IF(NMODE.NE.0)THEN
      IF(IUHF.NE.0)THEN
      CALL SKIPFW(ISCR,1)
      ENDIF
      WRITE(IOUT,115)
115   format(' Difference map - input of second set of data')
      CALL RMAPLO(iloop,ISCR,TY,RMAT,NY,NX,ADY,ADX,COSF)
      IMAP=IMAP+1
      IND=0
      RMAX=0.D0
      DO 73 IX=1,NX
      DO 73 IY=NY,1,-1
      IND=IND+1
      A(IX,IY)=A(IX,IY)-RMAT(IND)
73    RMAX=MAX(ABS(A(IX,IY)),RMAX)
      IF(RMAX.EQ.0.0D0)THEN
      WRITE(IOUT,107)
      STOP
      ENDIF
      ENDIF
      SINF=SQRT(1.D0-COSF*COSF)
      WY=(NY-1)*ADY*SINF
      WX=(NX-1)*ADX+ABS((NY-1)*ADY*COSF)
      YMM=AXISMM
      XMM=AXISMM*WX/WY
      IF(XMM.GT.A4W)THEN
      WRITE(IOUT,106)XMM,A4W
      XMM=A4W-40.d0
      YMM=XMM*WY/WX
      ENDIF
      XOFF=XMM*((NY-1)*ADY*ABS(COSF))/
     *         ((NY-1)*ADY*ABS(COSF)+(NX-1)*ADX)
      WRITE(IOUT,102)XMM,YMM
CBI
      FMAPX=XMM/WX
      FMAPY=YMM/WY
      WRITE(IOUT,102)FMAPX,FMAPY
      CALL PLOTCB(XMM,YMM,FMAPX,FMAPY)
C      CALL PLOT(XMM,YMM,-3)
CBF
      XL=XMM-XOFF
      YL=YMM/SINF
      IF(COSF.GT.0.D0)XOFF=0.D0
      DX=ADX
      DY=ADY
      VMIN=MINVAL(A(1:NX,1:NY))
      VMAX=MAXVAL(A(1:NX,1:NY))
      WRITE(IOUT,92)NL,VMIN,VMAX
C     DRAWING OF THE FRAME
      CALL PLOT(0.D0,0.D0,3)
      CALL PLOT(0.D0,YL,2)
      CALL PLOT(XL,YL,2)
      CALL PLOT(XL,0.D0,2)
      CALL PLOT(0.D0,0.D0,2)
C     ARRAYS WITH 2D GRID COORDINATES
      AX=0.D0
      AY=0.D0
      XINC=XL/(NX-1)
      YINC=YL/(NY-1)
      DO 20 I=1,NX
      X(I)=AX
      AX=AX+XINC
20    CONTINUE
      DO 21 I=1,NY
      Y(I)=AY
      AY=AY+YINC
21    CONTINUE
C     LOOP OVER THE CHOSEN FUNCTION VALUES
      IF (NL.GT.0) THEN
      DO KL =1,NL
      WRITE(IOUT,91)KL,ZLIV(KL)
      ZETA=ZLIV(KL)
      CALL LINLIV
      ENDDO
      ENDIF
      if(naf.ne.0)then
c *** ricerca atomi
c translation of points  A C - set B as origin (0., 0.,)
c bc vector (x1)
c ab vector (x2)
      x2(1)=xaa-xb
      x2(2)=yaa-yb
      x2(3)=zaa-zb
      rx2=sqrt(dot_product(x2,x2))
      x1(1)=xc-xb
      x1(2)=yc-yb
      x1(3)=zc-zb
      rx1=sqrt(dot_product(x1,x1))
c components of the vector v orthogonal to the plane abc
      xv(1)=  x1(2)*x2(3)-x1(3)*x2(2)
      xv(2)=-(x1(1)*x2(3)-x1(3)*x2(1))
      xv(3)=  x1(1)*x2(2)-x1(2)*x2(1)
      rxv=sqrt(dot_product(xv,xv))
c components of the vector y in the picture reference
      y2(1)=xv(2)*x1(3)-xv(3)*x1(2)
      y2(2)=xv(3)*x1(1)-xv(1)*x1(3)
      y2(3)=xv(1)*x1(2)-xv(2)*x1(1)
      ry2=sqrt(dot_product(y2,y2))
c components of AB (x2) in picture reference
      x2on1=dot_product(x2,x1)/rx1
      x2on2=dot_product(x2,y2)/ry2
      write(iout,202)x2on1,x2on2,0.,0.,0.,0.,rx1,0.,0.
      write(iout,203)
c generazione vettori reticolo diretto
      imax=5
      SELECT CASE(LDIM)
      CASE(3)
      ig=0
      do i3=-imax,imax
      do i2=-imax,imax
      do i1=-imax,imax
      ig=ig+1
      xg(1,ig)=i1*paret(1,1)+i2*paret(2,1)+i3*paret(3,1)
      xg(2,ig)=i1*paret(1,2)+i2*paret(2,2)+i3*paret(3,2)
      xg(3,ig)=i1*paret(1,3)+i2*paret(2,3)+i3*paret(3,3)
      enddo
      enddo
      enddo
      CASE(2)
      ig=0
      do i2=-imax,imax
      do i1=-imax,imax
      ig=ig+1
      xg(1,ig)=i1*paret(1,1)+i2*paret(2,1)
      xg(2,ig)=i1*paret(1,2)+i2*paret(2,2)
      xg(3,ig)=0.D0
      enddo
      enddo
      CASE(1)
      ig=0
      do i1=-imax,imax
      ig=ig+1
      xg(1,ig)=i1*paret(1,1)
      xg(2,ig)=0.D0
      xg(3,ig)=0.D0
      enddo
      CASE(0)
      ig=1
      xg(1,ig)=0.D0
      xg(2,ig)=0.D0
      xg(3,ig)=0.D0
      END SELECT
      rmax=sqrt(xg(1,ig)**2+xg(2,ig)**2+xg(3,ig)**2)
      write(iout,204)rmax
204   format(' direct lattice scanned up to R ',f12.6)
      do na=1,naf
      do m=1,ig
      xt(1)=xa(1,na)+XG(1,M)-xb
      xt(2)=xa(2,na)+XG(2,M)-yb
      xt(3)=xa(3,na)+XG(3,M)-zb
      rpb=sqrt(dot_product(xt(:),xt(:)))
c distance of the atom from the plane
      xp(3)=dot_product(xt(:),xv)/rxv
c projection of the segment BP on segment BC
      xp(1)=dot_product(xt(:),x1)/rx1
c projection on a axes ortogonal to v and 1
      xp(2)=dot_product(xt(:),y2)/ry2
c the atom is in the picture box?
      xbord=x2on1*xp(2)/x2on2
      if((xp(2).lt.x2on2+tolbox).and.(xp(2).gt.-tolbox).and.
     *(xp(1).gt.xbord-tolbox).and.
     *(xp(1)-rx1.lt.xbord+tolbox))then
c the atom is in the plane 
      if(iat2d.ne.0)write(iout,112)na,nat(na),symbat(na),m,(xp(i),i=1,3)
      if(abs(xp(3)).lt.tolzer)then
c
c *** comment to remove to print coordinates in 2D window
      write(imf,108)xp(1)*xmm/wx,xp(2)*ymm/wy,nat(na),symbat(na)
      write(iout,108)xp(1)*xmm/wx,xp(2)*ymm/wy,nat(na),symbat(na)
c
112   format(' atom',i4,' (Z',I3,')',1x,A,' g',i4,1p,3e18.10)
      endif
      endif
      enddo
      enddo
202   FORMAT(/' COORDINATES OF THE POINTS A,B,C IN 2D WINDOW (ANGSTROM)'
     *//T15,'A)',3(2X,f7.3)/
     *T15,'B)',3(2x,f7.3)/
     *T15,'C)',3(2x,f7.3))
203   FORMAT(/' COORDINATES OF THE ATOMS IN 2D WINDOWS REFERENCE',
     *' (ANGSTROM)'/' PRINTING COMMENTED IN maps05.f - REMOVE TO PRINT')
CBI
      WRITE(IMF,'(A4,2I5)') 'DRAW',IDRAW,ICOL
CBF
      endif
108   FORMAT('ATP',2F10.2,I4,2X,50A)
      IF(IUHF.NE.0.AND.ILOOP.NE.1)THEN
      IF(NMODE.EQ.0)THEN
      ZMAX=ABS(ZMAX)
      ZMAX=ZMAX*0.1D0
      NL=NL*2+1
      ZETA=-ZMAX
      DEZETA=(ZMAX-ZETA)/(NL-1)
      IF(NL.GT.NLIMAX)THEN
      PRINT *,' TOO MANY LEVELS (',NL,') - INCREASE NLIMAX'
      STOP
      ENDIF
      ZLIV(1)=ZETA
      DO 334 I=2,NL
      ZLIV(I)=ZLIV(I-1)+DEZETA
      IF(ABS(ZLIV(I)).LT.1E-10)ZLIV(I)=0.
334   CONTINUE
      ENDIF
      ENDIF
333   CONTINUE
      IF(ISCALE.EQ.2)IUHF=IUHSAV
      GOTO 10
999   IF(Icount.EQ.1)THEN
      WRITE(IOUT,104)
      STOP
      ELSE
      WRITE(IOUT,103)
      AXISMM=AXISAV
      IROUTE=IRSAVE
      REPEAT=.TRUE.
      GOTO 40
      ENDIF 
998   REWIND ISCR
      REWIND IPLOT
      REWIND IMF
100   FORMAT(' Map n. ',i4)
101   FORMAT(80A)
102   FORMAT(' Bounding Box size (mm)',2F10.4)
103   FORMAT(' MAP CONTROL DATA FROM PREVIOUS MAP')
104   FORMAT(' NO MAP CONTROL DATA FROM UNIT 5')
105   FORMAT(' WIDTH REDUCED TO A4 - IT WAS TOO LARGE ',F10.4)
106   FORMAT(' HEIGHT REDUCED TO A4',F7.1,' (INPUT DATUM',F7.1,')')
107   FORMAT(' DIFFERENCE MAP BETWEEN IDENTICAL DATA ')
110   FORMAT(A40)
109   FORMAT(' AB LENGTH',F7.1,'  (MAXIMUM SIZE',F7.1,')')
91    FORMAT (' Isodensity   : ',I5,5X,E11.3)
92    FORMAT (' No. isolines : ',I5,' vmin',1p,e15.7,' vmax',e15.7)
      STOP
      END
      SUBROUTINE EXTRACT(RMAT,IPOT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      parameter (lim016=10000)
      CHARACTER*4 TY
      character*2 symbat
      common/atomi/paret(3,3),xa(3,lim016),nat(lim016),NAF,LDIM
      common /framedat/XAA,YAA,ZAA,XB,YB,ZB,XC,YC,ZC
      common/symbat/symbat(lim016)
      COMMON /FILES/IPLOT,ISCR,IMF,IUHF,IFERMI,IIN,IOUT
      DIMENSION RMAT(*),IPOT(*)
      ixmgr=24
      IMAP=0
10    READ(IPLOT,200,END=999)MARK,TY,NR,NC,DXR,DXC,COSF
      NELEM=NR*NC
      IF(TY.EQ.'MAPN')THEN
      READ(IPLOT,221)XAA,YA,ZA,XB,YB,ZB,XC,YC,ZC,NAF,LDIM
      READ(IPLOT,220)(RMAT(II),II=1,NELEM)
      BMIN=MINVAL(RMAT(1:NELEM))
      BMAX=MAXVAL(RMAT(1:NELEM))
      IF(ABS(BMAX-BMIN).LT.1E-8)THEN
      WRITE(IOUT,251)
      do ii=1,naf
      read(iplot,1062)nat(ii),SYMBAT(ii),(XA(K,ii),K=1,3)
      enddo
      READ(IPLOT,110)((PARET(I,J),J=1,3),I=1,3)
      goto 10
      ENDIF
251   FORMAT(' ABS(VMAX-VMIN) LESS THAN 1E-8 - NO MAPS')
      if(nr.eq.1.or.nc.eq.1)then
      if(nr.eq.1)then
      write(iout,100)nc,dxc,xaa,ya,za,xb,yb,zb,xc,yc,zc
      write(ixmgr,220)nc,dxc
      do 11 ii=1,nc
11    write(ixmgr,220)dxc*(ii-1),rmat(ii)
      else
      write(iout,100)nr,dxr,xaa,ya,za,xb,yb,zb,xc,yc,zc
      write(ixmgr,222)nr,dxr
      do 12 ii=1,nr
12    write(ixmgr,220)dxr*(ii-1),rmat(ii)
      endif
      else
      WRITE(ISCR,202)MARK,TY,NR,NC,DXR,DXC,COSF
      WRITE(ISCR,221)XAA,YA,ZA,XB,YB,ZB,XC,YC,ZC,NAF,LDIM
      IMAP=IMAP+1
      IPOT(IMAP)=0
      IUHF=MOD(MARK,2)
      WRITE(ISCR,220)(RMAT(II),II=1,NELEM)
      do ii=1,naf
      read(iplot,1062)nat(ii),SYMBAT(ii),
     *(XA(K,ii),K=1,3)
      write(iscr,1062)nat(ii),SYMBAT(ii),
     *(XA(K,ii),K=1,3)
      enddo
      READ(IPLOT,110)((PARET(I,J),J=1,3),I=1,3)
      WRITE(ISCR,110)((PARET(I,J),J=1,3),I=1,3)
      IF(BMIN.LT.0.D0)IPOT(IMAP)=1
      WRITE(IOUT,203)IMAP,NR,(NR-1)*DXR,NC,(NC-1)*DXC,COSF,
     *BMIN,BMAX
      endif
      ELSE
      READ(IPLOT,200)IDUM
      READ(IPLOT,200)IDUM
      READ(IPLOT,220)(ADUM,I=1,NELEM)
      ENDIF
      GOTO 10
999   WRITE(IOUT,201)IMAP
      IF(IMAP.EQ.0)STOP
      REWIND IPLOT
      REWIND ISCR
      RETURN
100   format(' line plot - number of points',i4,' step',
     *1pe13.04,' a.u.'/' input coordinates for MAPNET '/
     *' A',3e12.4/' B',3E12.4/' C',3E12.4) 
110   FORMAT(3E20.12)
200   FORMAT(3X,I1,A4,2I5,3E12.5)
202   FORMAT('-%-',I1,A4,2I5,3E12.5)
201   FORMAT(' END OF DATA ON FORTRAN UNIT 25 -',I3,' DATA MATRICES')
203   FORMAT(' MAP N.',I3,' NROW, AB',I4,1P,E12.4,' NCOL,BC',I4,E12.4,
     *(' COS ANGLE ',0P,F8.3)//10x,' VALMIN',E12.4,' VALMAX',E12.4)
210   FORMAT(2I4,5F10.6)
220   FORMAT(1P,6E12.5)
221   FORMAT(1P,6E12.5/3E12.5,4X,2I4)
222   FORMAT(I4,6E12.5)
1062  FORMAT(I4,1X,A,1P,3E20.12)
      END
      SUBROUTINE DASH(X0,Y0,X1,Y1,Q0,III,KKK,IPP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION T(6,4),M(4)
      DATA T/4.0D0,2.0D0,4*0.D0,3.0D0,1.50D0,.500D0,
     *1.50D0,2*0.D0,0.50D0,1.0D0,4*5.0D0,
     *3.0D0,2.0D0,0.50D0,1.50D0,0.50D0,2.0D0/
C     DATA T/0.1D0,0.2D0,4*0.D0,0.3D0,0.15D0,0.05D0,
C    *0.15D0,2*0.D0,0.05D0,0.1D0,4*0.5D0,
C    *0.3D0,0.2D0,0.05D0,0.15D0,0.05D0,0.2D0/
      DATA M/2,4,2,6/
      DELTA=SQRT((X1-X0)**2+(Y1-Y0)**2)
      IF(DELTA.LT.1.D-06)DELTA=1.D-06
      UX=(X1-X0)/DELTA
      IND=0
      UY=(Y1-Y0)/DELTA
1     Q=Q0+T(III,KKK)
      IF(Q.LT.DELTA)GO TO 2
      IND=1
      Q=DELTA
      Q0=Q0-DELTA
2     X=X0+Q*UX
      Y=Y0+Q*UY
      ISIGN=(III/2)*2-III+3
      IF(IPP.EQ.3)  ISIGN=3
      CALL PLOT(X,Y,ISIGN)
      IF(IND.EQ.1)RETURN
      III=III+1
      Q0=Q
      IF(III.LE.M(KKK))GO TO 1
      III=1
      GO TO 1
      END
      SUBROUTINE LINEA(N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER(NPP1=500,NNMAX=NPP1*NPP1,NNMA2=NNMAX+2)
      COMMON /ISOLIN/XX(NNMA2),YY(NNMA2),X(NPP1),Y(NPP1),A(NPP1,NPP1),
     *      IP(NNMAX/2),JP(NNMAX/2)
      X1=XX(1)
      Y1=YY(1)
      CALL PLOT(X1,Y1,3)
      DO 3 I=2,N
      IPP=2
      X2=XX(I)
      Y2=YY(I)
C ****
C ****  CHECK DELLA MASCHERATURA
C ****
      CALL PLOT(X2,Y2,IPP)
3     CONTINUE
      RETURN
      END
      SUBROUTINE LINLIV
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER(NPP1=500,NNMAX=NPP1*NPP1,NNMA2=NNMAX+2)
      COMMON /ISOLIN/XX(NNMA2),YY(NNMA2),X(NPP1),Y(NPP1),A(NPP1,NPP1),
     *IP(NNMAX/2),JP(NNMAX/2)
      COMMON /PIVR/ZETA,DEZETA,J1,J2,I1,I2,KI,NI,KP,NP,DIV,
     *EX,DX,DY,NX,NY
      KP=0
C BORDO XMIN
      DO 6 J =2,NY
      IF (A(1,J-1).GE.ZETA.OR.A(1,J).LT.ZETA) GOTO 6
      I1=1
      J1=J
      I2=1
      J2=J-1
      YY(1)=Y(J2)+((Y(J1)-Y(J2))/(A(I1,J1)-A(I2,J2))*(ZETA-A(I2,J2)))
      XX(1)=X(I2)
      CALL PIVROT
6     CONTINUE
C  BORDO YMAX
      DO 7 I =2,NX
      IF (A(I-1,NY).GE.ZETA.OR.A(I,NY).LT.ZETA) GOTO 7
      I1=I
      J1=NY
      I2=I-1
      J2=NY
      YY(1)=Y(J2)
      XX(1)=X(I2)+((X(I1)-X(I2))/(A(I1,J1)-A(I2,J2))*(ZETA-A(I2,J2)))
      CALL PIVROT
7     CONTINUE
C  BORDO XMAX
      MY = NY - 1
      DO 8 IS = 1,MY
      J = NY - IS + 1
      IF (A(NX,J).GE.ZETA.OR.A(NX,J-1).LT.ZETA) GOTO 8
      I1=NX
      J1=J-1
      I2=NX
      J2=J
      YY(1)=Y(J2)+((Y(J1)-Y(J2))/(A(I1,J1)-A(I2,J2))*(ZETA-A(I2,J2)))
      XX(1)=X(I2)
      CALL PIVROT
8     CONTINUE
C  BORDO YMIN
      MX = NX - 1
      DO 9 IS = 1,MX
      I = NX - IS + 1
      IF (A(I,1).GE.ZETA.OR.A(I-1,1).LT.ZETA)GOTO 9
      I1=I-1
      J1=1
      I2=I
      J2=1
      YY(1)=Y(J2)
      XX(1)=X(I2)+((X(I1)-X(I2))/(A(I1,J1)-A(I2,J2))*(ZETA-A(I2,J2)))
      CALL PIVROT
9     CONTINUE
      DO 13 I =2,MX
      DO 12 J =2,NY
      IF (A(I,J-1).GE.ZETA.OR.A(I,J).LT.ZETA) GOTO 12
      IF (KP.EQ.0) GOTO 11
      DO 10 K =1,KP
      IF (IP(K).EQ.I.AND.JP(K).EQ.J) GOTO 12
10    CONTINUE
11    I1=I
      J1=J
      I2=I
      J2=J-1
      YY(1)=Y(J2)+((Y(J1)-Y(J2))/(A(I1,J1)-A(I2,J2))*(ZETA-A(I2,J2)))
      XX(1)=X(I2)
      CALL PIVROT
12    CONTINUE
13    CONTINUE
      RETURN
      END
      SUBROUTINE PIVROT
C
C       COSTRUZIONE CURVA A LIVELLO ZETA
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /PIVR/ZETA,DEZETA,J1,J2,I1,I2,KI,NI,KP,NP,DIV,
     *  EX,DX,DY,NX,NY
      PARAMETER(NPP1=500,NNMAX=NPP1*NPP1,NNMA2=NNMAX+2)
      COMMON /ISOLIN/XX(NNMA2),YY(NNMA2),X(NPP1),Y(NPP1),A(NPP1,NPP1),
     *      IP(NNMAX/2),JP(NNMAX/2)
      COMMON /FILES/IPLOT,ISCR,IMF,IUHF,IFERMI,IIN,IOUT
      KI=1
      INDIC1=0
8     IF (I1.NE.I2) GOTO 12
      I3=I2
      J3=J2
      IF (J1.GT.J2) GOTO 11
      I2=I2-1
      GOTO 14
11    I2=I2+1
      GOTO 14
12    IF(J1.NE.J2) GOTO 18
      I3=I2
      J3=J2
      IF (I1.LT.I2)GOTO 13
      J2=J2-1
      GOTO 14
13    J2=J2+1
14    ZETB=(A(I1,J1)+A(I2,J2)+A(I1,J2)+A(I2,J1))/4.D0
      KI=KI+1
      IF(KI.GT.NI) GOTO 41
      IF(KI.GT.NNMA2) THEN
      PRINT *,' INCREASE XX AND YY DIMENSION TO ',KI
      STOP
      ENDIF
      IF (ZETB.LT.ZETA) GOTO 15
      IF (A(I2,J2).LT.ZETA) GOTO 16
      YY(KI)=Y(J3)+((ZETA-A(I3,J3))/(ZETB-A(I3,J3))*
     *  ((Y(J1)+Y(J2))/2.D0-Y(J3)))
      XX(KI)=X(I3)+((ZETA-A(I3,J3))/(ZETB-A(I3,J3))*
     *  ((X(I1)+X(I2))/2.D0-X(I3)))
      GOTO  23
15    YY(KI)=Y(J1)+((ZETA-A(I1,J1))/(ZETB-A(I1,J1))*
     *  ((Y(J1)+Y(J2))/2.D0-Y(J1)))
      XX(KI)=X(I1)+((ZETA-A(I1,J1))/(ZETB-A(I1,J1))*
     *  ((X(I1)+X(I2))/2.D0-X(I1)))
      GOTO 8
16    YY(KI)=Y(J2)+((ZETA-A(I2,J2))/(ZETB-A(I2,J2))*
     *  ((Y(J1)+Y(J2))/2.D0-Y(J2)))
      XX(KI)=X(I2)+((ZETA-A(I2,J2))/(ZETB-A(I2,J2))*
     *  ((X(I1)+X(I2))/2.D0-X(I2)))
      IF(INDIC1.EQ.0) GOTO 17
      XB=XX(KI-1)
      YB=YY(KI-1)
      XX(KI-1)=XX(KI)
      YY(KI-1)=YY(KI)
      XX(KI)=XB
      YY(KI)=YB
      INDIC1=0
      GOTO 8
17    INDIC1=1
      GOTO 8
18    IF(I1.LE.I2) GOTO 20
      IF(J1.GT.J2) GOTO 19
      J2=J2-1
      GOTO 22
19    I2=I2+1
      GOTO 22
20    IF(J1.LT.J2) GOTO 21
      J2=J2+1
      GOTO 22
21    I2=I2-1
22    IF (A(I2,J2).LT.ZETA) GOTO 24
23    I3=I1
      J3=J1
      I1=I2
      J1=J2
      I2=I3
      J2=J3
      KP=KP+1
      IF(KP.GT.NNMAX/2) THEN
      PRINT *,' INCREASE IP&JP DIM (NNMAX/2,NNMAX) TO ',KP,KI
      STOP
      ENDIF
      IF(KP.GT.NP)GOTO 43
      IP (KP)=I1
      JP(KP)=J1
      GOTO 8
24    KI=KI+1
      IF(KI.GT.NNMA2) THEN
      PRINT *,' INCREASE XX AND YY DIMENSION TO ',KI
      STOP
      ENDIF
      IF(KI.GT.NI) GOTO 41
      INDIC1=0
      IF (I1.EQ.I2) GOTO 25
      YY(KI)=Y(J1)
      XX(KI)=X(I1)+((ZETA-A(I1,J1))/(A(I2,J2)-A(I1,J1))*
     *  (X(I2)-X(I1)))
      GOTO 26
25    YY(KI)=Y(J1)+((ZETA-A(I1,J1))/(A(I2,J2)-A(I1,J1))*
     *  (Y(J2)-Y(J1)))
      XX(KI)=X(I1)
26    KN=0
      IF(ABS(XX(KI)-XX(1)).LE.EX.AND.ABS(YY(KI)-YY(1)).LE.EX)GOTO 30
      IF(ABS(XX(KI)-X(NX)).LE.EX) GOTO 30
      IF(ABS(YY(KI)-Y(NY)).LE.EX) GOTO 30
      IF(ABS(XX(KI)-X(1)).LE.EX) GOTO 30
      IF(ABS(YY(KI)-Y(1)).LE.EX) GOTO 30
      GOTO 8
C
C       COSTRUZIONE ETICHETTA CURVA DI LIVELLO
C
30    CONTINUE
97    SOGLIA=0.00001D0
      IF(ZETA.GT.SOGLIA)CALL LINEA(KI)
      IF(ZETA.LT.-SOGLIA)CALL TRATTO(KI,1)
      IF(ABS(ZETA).LT.SOGLIA)CALL TRATTO(KI,2)
98    CONTINUE
      RETURN
C
C       ERRORI-AREE INSUFFICIENTI
C
41    WRITE(IOUT,42) KI,ZETA
      GOTO    30
42    FORMAT('  KI,ZETA ',I10,F20.3)
43    WRITE(IOUT,46) NI,NP,KI,KP
46    FORMAT(' NI,NP,KI,KP',4I10)
      RETURN
      END
      SUBROUTINE PLOT(X,Y,IMODO)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /ROMB/ COSF,SINF
      COMMON /LINE/ XOLD,YOLD,ISTAT
      COMMON /OFF/ XOFF
      COMMON /FILES/IPLOT,ISCR,IMF,IUHF,IFERMI,IIN,IOUT
      IF (IMODO.EQ.-3) THEN
      WRITE(IMF,201)'COOR',X,Y
      RETURN
      ENDIF
      X0=XOFF+(X+Y*COSF)
      Y0=Y*SINF
      IF (IMODO.EQ.3) THEN
      XOLD=X0
      YOLD=Y0
      ISTAT=1
      ELSEIF (IMODO.EQ.2) THEN
      IF (ISTAT.EQ.1) THEN
      ISTAT=0
      WRITE(IMF,201) 'LINE',XOLD,YOLD,X0,Y0
      ELSE
      WRITE(IMF,201) 'LINT',X0,Y0
      ENDIF
      ENDIF
201   FORMAT(A4,4F10.2)
      RETURN
      END
CBI
      SUBROUTINE PLOTCB(X,Y,FMAPX,FMAPY)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /FILES/IPLOT,ISCR,IMF,IUHF,IFERMI,IIN,IOUT
      WRITE(IMF,200)'COOR',X,Y,FMAPX,FMAPY
200   FORMAT(A4,2F10.2,2F12.4)
      RETURN
      END
CBF
C***./ ADD NAME=RMAPLO
      SUBROUTINE RMAPLO(iloop,IPLOT,TY,RMAT,NR,NC,DXR,DXC,COSF)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      parameter (lim016=10000)
      CHARACTER*4 TY
      CHARACTER*4 itit(18)
      character*2 symbat
      common/atomi/paret(3,3),xa(3,lim016),nat(lim016),NAF,LDIM
      common /framedat/XAA,YAA,ZAA,XB,YB,ZB,XC,YC,ZC
      common/symbat/symbat(lim016)
      DIMENSION RMAT(*)
      IOUT=6
      READ(IPLOT,200,END=999)IHFERM,TY,NR,NC,DXR,DXC,COSF
      READ(IPLOT,221,END=999)XAA,YAA,ZAA,XB,YB,ZB,XC,YC,ZC,NAF,LDIM
      NELEM=NR*NC
      if(nelem.eq.0)then
      write(iout,212)nr,nc
212   format(' no data to plot - nr, nc',2i4)
      return
      endif
      READ(IPLOT,220,END=999)(RMAT(J),J=1,NELEM)
      WRITE(IOUT,250)NELEM,NR,NC,IPLOT,XAA,YAA,ZAA,XB,YB,ZB,NR,
     *XC,YC,ZC,NR,NC
      VMAX=RMAT(1)
      VMIN=VMAX
      DO 1 J=1,NELEM
      VMAX=MAX(VMAX,RMAT(J))
      VMIN=MIN(VMIN,RMAT(J))
1     CONTINUE
      IF(ABS(VMAX-VMIN).LT.1E-8)THEN
      WRITE(IOUT,251)
      nr=0
      return
      ENDIF
      write(iout,113)
      do na=1,naf
      read(iplot,1062)nat(na),SYMBAT(na),
     *(XA(K,na),K=1,3)
      write(iout,112)na,nat(na),symbat(na),(xa(K,na),K=1,3)
112   format(' atom',i4,' (Z',I3,')',2x,A,1p,3e20.12)
      enddo
      READ(IPLOT,110)((PARET(I,J),J=1,3),I=1,3)
      call parcel(paret)
110   FORMAT(3E20.12)
113   format(/
     *' COORDINATES OF THE ATOMS IN THE REFERENCE CELL (ANGSTROM)'/)
250   FORMAT(I5,' DATA  (',I3,',',I3,') READ FROM UNIT',I3/
     *' COORDINATES OF THE POINTS DEFINING THE WINDOWS (ANGSTROM):'/
     *      T15,'A)',3F9.3,' POINT INDICES (  1,  1)'/
     *      T15,'B)',3F9.3,' POINT INDICES (',I3,',  1)'/
     *      T15,'C)',3F9.3,' POINT INDICES (',I3,',',I3,')')
251   FORMAT(' ABS(VMAX-VMIN) LESS THAN 1E-8 - NO MAPS')
220   FORMAT(1P,6E12.5)
221   FORMAT(1P,6E12.5/3E12.5,4X,2I4)
200   FORMAT(3X,I1,A4,2I5,3E12.5)
201   FORMAT(' MAP PLOT - END OF DATA ON FORTRAN UNIT 25')
1062  FORMAT(I4,1X,A,1P,3E20.12)
      RETURN
999   WRITE(IOUT,201)
      STOP
      END
      SUBROUTINE TRATTO(N,KKK)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER(NPP1=500,NNMAX=NPP1*NPP1,NNMA2=NNMAX+2)
      COMMON /ISOLIN/XX(NNMA2),YY(NNMA2),X(NPP1),Y(NPP1),A(NPP1,NPP1),
     *      IP(NNMAX/2),JP(NNMAX/2)
      X0=XX(1)
      Y0=YY(1)
      CALL PLOT(X0,Y0,3)
      III=1
      Q0=0.D0
      DO 3 I=2,N
      IPP=2
      X1=XX(I)
      Y1=YY(I)
C ****
C ****  CHECK DELLA MASCHERATURA
C ****
      CALL DASH(X0,Y0,X1,Y1,Q0,III,KKK,IPP)
      X0=X1
      Y0=Y1
3     CONTINUE
      RETURN
      END
C***./ ADD NAME=SKIPBW
      SUBROUTINE SKIPBW(IPLOT,NSKIP,NELEM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*80 ADUM
      IOUT=6
      READ(IPLOT,200,END=999)ADUM
      WRITE(IOUT,200)ADUM
      BACKSPACE IPLOT
      NUMREC=NELEM/6
      IF(MOD(NELEM,6).NE.0)NUMREC=NUMREC+1
      DO 1 ISK=1,NSKIP
      BACKSPACE IPLOT
      BACKSPACE IPLOT
      BACKSPACE IPLOT
      do 2 in=1,numrec
      backspace iplot
2     continue
1     continue
      READ(IPLOT,200,END=999)adum
      write(iout,200)adum
200   FORMAT(a)
      backspace iplot
      RETURN
999   stop
      END
C***./ ADD NAME=skipfw
      SUBROUTINE skipfw(IPLOT,nskip)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*4 TY
      iout=6
      do 1 isk=1,nskip
      READ(IPLOT,200,END=999)IHFERM,TY,NR,NC,DXR,DXC,COSF
      READ(IPLOT,221,END=999)XAA,YA,ZA,XB,YB,ZB,XC,YC,ZC,NAF
      NELEM=NR*NC
      READ(IPLOT,220,END=999)(RMAT,J=1,NELEM)
1     continue
220   FORMAT(1P,6E12.5)
200   FORMAT(3X,I1,A4,2I4,3E12.5)
221   FORMAT(1P,6E12.5/3E12.5,4X,I4)
201   FORMAT(' skipping - END OF DATA ON FORTRAN UNIT 25')
      RETURN
999   WRITE(IOUT,201)
      STOP
      END
      SUBROUTINE PARCEL(C)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /FILES/IPLOT,ISCR,IMF,IUHF,IFERMI,IIN,IOUT
      DIMENSION C(3,3),A(6)
      PAR33=180.D0/(ACOS(0.D0)*2.D0)
      DO 2 I=1,3
2     A(I)=SQRT(C(I,1)*C(I,1)+C(I,2)*C(I,2)+C(I,3)*C(I,3))
      A(4)=ACOS((C(2,1)*C(3,1)+C(2,2)*C(3,2)+C(2,3)*C(3,3))
     */(A(2)*A(3)))*PAR33
      A(5)=ACOS((C(1,1)*C(3,1)+C(1,2)*C(3,2)+C(1,3)*C(3,3))
     */(A(1)*A(3)))*PAR33
      A(6)=ACOS((C(1,1)*C(2,1)+C(1,2)*C(2,2)+C(1,3)*C(2,3))
     */(A(1)*A(2)))*PAR33
      write(iout,100)(A(i),i=1,6)
100   format(/
     *' LATTICE PARAMETERS  (ANGSTROMS AND DEGREES) - PRIMITIVE CELL'
     */'       A          B          C         ALPHA',
     *'      BETA     GAMMA'/3F11.5,2X,3F10.4/)
      RETURN
      END
