      subroutine atdraw(fatc,natomi,ips,idraw,icol)
      parameter(lim016=10000)
      common/atomi/nat(lim016),xa(lim016),ya(lim016),za(lim016)
      dimension ibond(lim016*4,2),ilink(lim016),plan(lim016)
      dimension cr(0:102),gr(0:102),vr(0:102),fcpk(0:102)
      character*2 atsym(0:102)
      dimension atrgb(0:102,3),athsb(0:102,3),atgray(0:102)
      character*80 line
      write(*,'(a)')' All printing instructions commented'
      fat=0.529177249
c     fati=1./0.529177249
      fati=1.
      fatps=72./25.4
      fatgr=0.33333333
      fatr=0.45
      fats=2.
C
      za(1:lim016)=0.0
      plan(1:lim016)=0.0
C
      write(*,'(a16)') 'Atomic positions'
      do i=1,natomi
      xa(i)=xa(i)*fatps
      ya(i)=ya(i)*fatps
c     write(*,'(i4,2x,i4,2x,2f10.2)') i,nat(i),xa(i),ya(i)
      enddo
C
c     --------------------------------------------------
c     read atomic parameters from: mptparam.dat
c     --------------------------------------------------
      open(unit=20,file='mptparam.dat',form='formatted')
      do 10 i=1,12
      read(20,'(a80)')
10    continue
      do 11 k=0,102
      read(20,202) cr(k),gr(k),vr(k),fcpk(k),atsym(k),
     *(atrgb(k,i),i=1,3),(athsb(k,i),i=1,3),atgray(k)
11    continue
      close(20)
202   format(4x,3f7.2,f6.1,a2,16x,3f5.2,2x,3f5.3,2x,f5.3)
203   format(4x,3f7.2,f6.1,1x,a2,05x,3f5.2,2x,3f5.3,2x,f5.3)
c     --------------------------------------------------
c     calcola le connettivita' per la rappresentazione
c     dei legami
c     --------------------------------------------------
      ff=fatps*fatc*fati
      write(*,'(a17)') 'Atomic parameters'
      do 30 j=1,natomi
      k=mod(nat(j),100)
c     write(*,203) cr(k),gr(k),vr(k),fcpk(k),atsym(k),
c    *(atrgb(k,i),i=1,3),(athsb(k,i),i=1,3),atgray(k)
      ilink(j)=j
30    continue
      call conn(natomi,ff,ilink,cr,ibond,jbond)
      write(*,'(a19)') 'Atomic connectivity'
c     write(*,'(i5)') jbond
      do 31 j=1,jbond
c     write(*,'(i2,2x,i2)') ibond(j,1),ibond(j,2)
31    continue
c     --------------------------------------------------
c     read PS definitions to plot atoms from defps.dat
c     --------------------------------------------------
      open(unit=20,file='defps.dat',form='formatted')
1970  read(20,'(a80)',end=1971) line
      write(ips,'(a80)') line
      goto 1970
1971  continue
c     --------------------------------------------------
c     PostScript printing
c     --------------------------------------------------
      mdraw=abs(idraw)
      select case(mdraw)
      case(0)
C *** no plotting
      return
      case(1)
C *** plotting atomic symbols
      do j=1,natomi
      k=mod(nat(j),100)
      xl=xa(j)-6.
      yl=ya(j)-6.
      if(idraw.gt.0)call labels(xl,yl,atsym(k),ips)
      enddo
      case(2)
C *** plotting atomic framework and labels
      fgr=fatps*fatc*fatgr*fati
      call wire(ilink,plan,atrgb,atgray,jbond,ibond,ips,
     *icol)
      if(idraw.gt.0)then
      do j=1,natomi
      k=mod(nat(j),100)
      if(idraw.gt.0)call labels(xa(j),ya(j),atsym(k),ips)
      enddo
      endif
      case(3)
C *** plotting atomic positions as balls-stick and labels
      fgr=fatps*fatc*fatgr*fati
      call wire(ilink,plan,atrgb,atgray,jbond,ibond,ips,
     *icol)
      psi=gr(mod(nat(1),100))*fgr
      delta=psi
c     print*,'psi',psi
      call balls(plan,atrgb,atgray,atsym,gr,fgr,
     *          natomi,delta,psi,fatr,ips,icol,idraw)
      case(4)
C *** plotting atoms as vdW-spheres and labels
      fgr=fatps*fatc*fati
      call shade_new(plan,vr,fcpk,athsb,atrgb,atgray,atsym,
     *fgr,natomi,ips,icol,idraw)
      case(5)
      return
      end select
      return
      end
      subroutine balls(plan,atrgb,atgray,atsym,gr,fgr,
     *                 natomi,delta,psi,fatr,ips,icol,idraw)
c     --------------------------------------------------
c     plot atoms as balls 
c     --------------------------------------------------
      parameter(lim016=10000)
      common/atomi/nat(lim016),xa(lim016),ya(lim016),za(lim016)
      dimension plan(lim016)
      character*2 atsym(0:102)
      dimension atgray(0:102),gr(0:102),atrgb(0:102,3)
201   format(2f7.2,a4,a2,a8)
      tolp=0.00001
      write(ips,'(a40)') '%-------- plot of atoms as "balls"-------'
      write(ips,'(a7)') 'newpath'
      write(ips,'(a14)') '1 setlinewidth'
      do 10 j=1,natomi
      k=mod(nat(j),100)
      call ranf_new(j,delta,psi,gr,fatr,rasc)
      ff=rasc
      ff1=ff+fgr*0.1
      if (abs(plan(j)).lt.tolp) then
      write(ips,'(a12)') '[] 0 setdash'
       if(icol.ne.0) then
       write(ips,'(3f5.2,1x,a11)') (atrgb(k,i),i=1,3),'setrgbcolor'
       else
       write(ips,'(f5.3,1x,a7)') atgray(k),'setgray'
       endif
      write(ips,'(3f9.2,1x,a12)') xa(j),ya(j),ff,'docirclefill'
      write(ips,'(3f9.2,1x,a8)') xa(j),ya(j),ff,'docircle'
      write(ips,'(3f9.2,1x,a8)') xa(j),ya(j),ff,'doglobes'
      xx=xa(j)+ff*0.4
      yy=ya(j)+ff*0.4
      rsp=ff*0.15
      write(ips,'(3f7.2,1x,a6)') xx,yy,rsp,'dospot'
      xl=xa(j)+ff1
      yl=ya(j)+ff1
      if(idraw.gt.0)call labels(xl,yl,atsym(k),ips)
      else
      write(ips,'(a15)') '[1 2] 0 setdash'
      write(ips,'(3f9.2,1x,a8)') xa(j),ya(j),ff,'docircle'
c     write(ips,'(3f9.2,1x,a8)') xa(j),ya(j),ff,'doglobes'
      write(ips,'(a9)') '0 setgray'
      xl=xa(j)+ff1
      yl=ya(j)+ff1
      if(idraw.gt.0)write(ips,201) xl,yl,' m (',atsym(k),') show s'
      endif
10    continue
      return
      end
      subroutine conn(natomi,ff,ilink,cr,ibond,jbond)
c     --------------------------------------------------
c     computes atomic connectivity
c     --------------------------------------------------
      parameter(lim016=10000)
      common/atomi/nat(lim016),xa(lim016),ya(lim016),za(lim016)
      dimension ibond(lim016*4,2),ilink(lim016)
      dimension cr(0:102)
      nat1=natomi-1
      itrov=0
      tolv=0.2*ff
      do 10 l=1,nat1
       k=ilink(l)
       xt=xa(k)
       yt=ya(k)
       zt=za(k)
       na1=mod(nat(k),100)
       r1=cr(na1)*ff+tolv
       l1=l+1
       do 20 j=l1,natomi
        i=ilink(j)
        na2=mod(nat(i),100)
        if (na1+na2.ne.2) then
          r2=cr(na2)*ff+tolv
          dist=0.0
          r22=r2+r1
          r22=r22*r22
          d1=xt-xa(i)
          dist=dist+d1*d1
          if (dist.lt.r22) then
             d1=yt-ya(i)
             dist=dist+d1*d1
             if (dist.lt.r22) then
                d1=zt-za(i)
                dist=dist+d1*d1
                if (dist.lt.r22) then
                   itrov=itrov+1
c                   If itrov > maxbond Then
c                      Call recov
c                      Exit Sub
c                   End If
                   ibond(itrov,1)=l
                   ibond(itrov,2)=j
                endif
             endif
          endif
        endif
20     continue
10    continue
      jbond=itrov
      if (jbond.eq.0) then
         do 30 k=1,natomi
           ibond(k,1)=k
           ibond(k,2)=k
30       continue
         jbond=natomi
      endif
c     kcon=1
      return
      end
C
      subroutine labels(xl,yl,asy,ips)
c     --------------------------------------------------
c     plot atoms as balls 
c     --------------------------------------------------
      character*2 asy
      write(ips,'(a9)') '0 setgray'
      write(ips,201) xl,yl,' m (',asy,') show s'
201   format(2f7.2,a4,a2,a8)
      return
      end
      SUBROUTINE POS(LABEL,I1,I2)
      CHARACTER*50 LABEL
      J=51
30    J=J-1
      IF ((LABEL(J:J).EQ.' ').AND.(J.GT.2)) GOTO 30
      I2=J
      J=1
31    J=J+1
      IF ((LABEL(J:J).EQ.' ').AND.(J.LT.I2)) GOTO 31
      I1=J
      RETURN
      END
C     *****************************************************
C
C                    CrGraph Package V3.0
C                      POSTSCR Program
C
C             Ales Zupan, IJS, Ljubljana, SLOVENIA
C
C     You may copy and distribute this package only in its
C     original form. New owner is asked to send me an E-mail
C     or normal mail to become a registered user.
C
C     All registered users are entitled to free future versions,
C     which will be distributed through E-mail
C
C     Please, report all difficulties on my E-mail address!
C
C     *****************************************************
      PROGRAM PS
      CHARACTER*4 KEYW
      CHARACTER*80 LINE
      CHARACTER*50 LABEL
CBI
      parameter(lim016=10000)
      common/atomi/nat(lim016),xa(lim016),ya(lim016),za(lim016)
CBF
c *** unita' di misura postscript: 1/72 pollice (2.54 mm)
c *** i dati in arrivo dal metafile devono essere in mm
      FACT=72./25.4
      IPS=21
      IMF=18
      WRITE(*,100) ' Postscript driver'
      WRITE(*,100) ' Written by Ales Zupan, IJS, Slovenia, Email ',
     *'ales.zupan@ijs.ac.mail.yu'
      WRITE(*,100) ' *** Plotting of atoms by B. Civalleri ***'
      WRITE(*,*)
      WRITE(*,100) ' Creating Postscript file'
      WRITE(IPS,100) '%!PS-Adobe-2.0 EPSF-1.2'
      WRITE(IPS,100) '%%Title: Crystal Graphical Output'
      WRITE(IPS,100) '%%BoundingBox: 10 20 540 760'
      WRITE(IPS,100) '%%EndComments'
      WRITE(IPS,100) '/m {moveto} def'
      WRITE(IPS,100) '/l {lineto} def'
      WRITE(IPS,100) '/s {stroke} def'
      WRITE(IPS,100) 'newpath'
      WRITE(IPS,100) '0.7 setlinewidth'
      WRITE(IPS,100) '40 100 translate'
      WRITE(IPS,100) '0 0 m'
CBI
      iccb=0
CBF
1     READ(IMF,100,END=999) LINE
      READ(LINE(1:4),101) KEYW
      IF(KEYW.EQ.'NEWP')THEN
      WRITE(IPS,100) 'stroke showpage'
      WRITE(IPS,100) 'newpath'
      WRITE(IPS,100) '0.7 setlinewidth'
      WRITE(IPS,100) '40 100 translate'
      WRITE(IPS,100) '0 0 m'
      WRITE(*,100)'newpage'
      ELSEIF(KEYW.EQ.'CONT')THEN
      WRITE(IPS,100)'[] 0 setdash'
      ELSEIF(KEYW.EQ.'DASH')THEN
      WRITE(IPS,100)'[2 4] 0 setdash'
      ELSEIF (KEYW.EQ.'LINE') THEN
      READ(LINE(5:80),102) X1,Y1,X2,Y2
      WRITE(IPS,104) X1*FACT,Y1*FACT
      WRITE(IPS,105) X2*FACT,Y2*FACT
      ELSEIF (KEYW.EQ.'LINT') THEN
      READ(LINE(5:80),102) X1,Y1
      WRITE(IPS,105) X1*FACT,Y1*FACT
      ELSEIF (KEYW.EQ.'CHAR') THEN
      READ(LINE(5:80),102) WY
      WY=WY*FACT
      WRITE(IPS,109) WY
      ELSEIF (KEYW.EQ.'STCB') THEN
      READ(LINE(5:80),106) X1,Y1,LABEL
      CALL POS(LABEL,I1,I2)
      IF (LABEL(2:I2).EQ.'Gamma') THEN
      WRITE(IPS,110) WY
      WRITE(IPS,123) CHAR(92),107
123   FORMAT('(',1A,I3,') dup stringwidth pop 2. div')
      WRITE(IPS,107) X1*FACT,' exch sub'
      WRITE(IPS,107) Y1*FACT,' m show'
      WRITE(IPS,109) WY
      ELSEIF (LABEL(2:I2).EQ.'Delta') THEN
      WRITE(IPS,110) WY
      WRITE(IPS,123) char(92),104
      WRITE(IPS,107) X1*FACT,' exch sub'
      WRITE(IPS,107) Y1*FACT,' m show'
      WRITE(IPS,109) WY
      ELSEIF (LABEL(2:I2).EQ.'Sigma') THEN
      WRITE(IPS,110) WY
      WRITE(IPS,123) char(92),123
      WRITE(IPS,107) X1*FACT,' exch sub'
      WRITE(IPS,107) Y1*FACT,' m show'
      WRITE(IPS,109) WY
      ELSEIF (LABEL(2:I2).EQ.'Lambda') THEN
      WRITE(IPS,110) WY
      WRITE(IPS,123) char(92),114
      WRITE(IPS,107) X1*FACT,' exch sub'
      WRITE(IPS,107) Y1*FACT,' m show'
      WRITE(IPS,109) WY
      ELSE
      IF (I2.EQ.-1900) THEN
      I2=0
      ENDIF
      WRITE(IPS,100) '(',LABEL(2:I2),')'
      WRITE(IPS,100) 'dup stringwidth pop 2. div'
      WRITE(IPS,107) X1*FACT,' exch sub'
      WRITE(IPS,107) Y1*FACT,' m show'
      ENDIF
      ELSEIF (KEYW.EQ.'STLC') THEN
      READ(LINE(5:80),106) X1,Y1,LABEL
      CALL POS(LABEL,I1,I2)
      WRITE(IPS,100) '(',LABEL(2:I2),')',' dup',
     *' stringwidth exch pop 2. div'
      WRITE(IPS,106) X1*FACT,Y1*FACT,' 3 2 roll sub m show'
      ELSEIF (KEYW.EQ.'STLB') THEN
      READ(LINE(5:80),106) X1,Y1,LABEL
      CALL POS(LABEL,I1,I2)
      WRITE(IPS,106) X1*FACT,Y1*FACT,' m'
      WRITE(IPS,100) '(',LABEL(2:I2),')',' show'
      ELSEIF (KEYW.EQ.'STRC') THEN
      READ(LINE(5:80),106) X1,Y1,LABEL
      CALL POS(LABEL,I1,I2)
      WRITE(IPS,100) '(',LABEL(I1:I2),')',' dup stringwidth',
     *' 2. div'
      WRITE(IPS,107) Y1*FACT,' exch sub exch'
      WRITE(IPS,107) X1*FACT,' exch sub exch m show'
      ELSEIF (KEYW.EQ.'STDU') THEN
      READ(LINE(5:80),106) X1,Y1,LABEL
      CALL POS(LABEL,I1,I2)
      WRITE(IPS,100) '(',LABEL(2:I2),')',' dup stringwidth',
     *' exch 2. div'
      WRITE(IPS,107) Y1*FACT,' exch sub exch'
      WRITE(IPS,107) X1*FACT,' add exch m 90 rotate show -90 rotate'
      elseif (keyw.eq.'ATP') then
      iccb=iccb+1
      read(line(5:80),108) xa(iccb),ya(iccb),nat(iccb),label
CBI
      elseif (keyw.eq.'COOR') then
      read(line(5:80),'(2f10.2,2f12.4)') xmap,ymap,fmapx,fmapy
c     print *,'fmapx=',fmapx,'fmapy=',fmapy,'xmap/ymap=',xmap/ymap
      elseif (keyw.eq.'DRAW') then
      read(line(5:80),'(2i5)') idraw,icol
c     write(*,*) iccb
      call atdraw(fmapx,iccb,ips,idraw,icol)
      iccb=0
CBF
      ENDIF
      GOTO 1
999   WRITE(IPS,100) 'stroke showpage'
C
100   FORMAT(80A)
101   FORMAT(4A)
102   FORMAT(4F10.2)
104   FORMAT('s ',2F10.2,' m')
105   FORMAT(2F10.2,' l')
106   FORMAT(2F10.2,50A)
107   FORMAT(F10.2,80A)
108   FORMAT(2F10.2,I4,50A)
109   FORMAT('/Helvetica findfont',F10.2,' scalefont setfont')
110   FORMAT('/Symbol findfont',F10.2,' scalefont setfont')
      END
      subroutine ranf_new(j,delta,psi,gr,fatr,rasc)
      parameter(lim016=10000)
      common/atomi/nat(lim016),xa(lim016),ya(lim016),za(lim016)
      dimension gr(0:102)
      ra=abs(delta*za(j)+psi)
      ra1=ra*gr(mod(nat(j),100))/gr(mod(nat(1),100))
      rasc=ra1*fatr
      return
      end
      subroutine shade_new(plan,vr,fcpk,athsb,atrgb,atgray,atsym,
     *fgr,natomi,ips,icol,idraw)
c     --------------------------------------------------
c     plot of atoms as van der Waals spheres (to be checked)
c     --------------------------------------------------
      parameter(lim016=10000)
      common/atomi/nat(lim016),xa(lim016),ya(lim016),za(lim016)
      dimension plan(lim016)
      character*2 atsym(0:102)
      dimension atgray(0:102),athsb(0:102,3),atrgb(0:102,3)
      dimension vr(0:102),fcpk(0:102)
      tolp=0.00001
      write(ips,'(a7)') 'newpath'
      write(ips,'(a14)') '1 setlinewidth'
      write(ips,'(a7)') '90 -1 1'
      write(ips,'(a15)') '{ /ang exch def'
      do j=1,natomi
      k=mod(nat(j),100)
      ff=vr(k)*fcpk(k)*fgr
      if (abs(plan(j)).lt.tolp) then
      if(icol.ne.0)then
      write(ips,'(2f6.3,1x,a19)') athsb(k,1),athsb(k,2),
     *                          'ang cos sethsbcolor'
      else
      write(ips,'(f5.3,1x,a15)') atgray(k),'ang cos setgray'
      endif
      write(ips,'(a13,f7.3,a8)') '/rad ang sin ',ff,' mul def'
      write(ips,'(2f9.2,2x,a16)') xa(j),ya(j),'rad docirclefill'
      endif
      enddo
      write(ips,'(a5)') '} for'
      do j=1,natomi
      k=mod(nat(j),100)
      xl=xa(j)-6.
      yl=ya(j)-6.
      if(idraw.gt.0)call labels(xl,yl,atsym(k),ips)
      enddo
      return
      end
      subroutine wire(ilink,plan,atrgb,atgray,jbond,ibond,
     *ips,icol)
c     --------------------------------------------------
c     plot of the atomic framework as wires of different thickness
c     --------------------------------------------------
      parameter(lim016=10000)
      common/atomi/nat(lim016),xa(lim016),ya(lim016),za(lim016)
      dimension plan(lim016)
      dimension ibond(lim016*4,2),ilink(lim016)
      dimension atgray(0:102),atrgb(0:102,3)
      tolp=0.00001
      write(ips,'(a7)') 'newpath'
      write(ips,'(a14)') '3 setlinewidth'
      write(ips,'(a13)') '1 setlinejoin'
      do 10 j=1,jbond
      n=ilink(ibond(j,1))
      n1=ilink(ibond(j,2))
      k=mod(nat(n),100)
      k1=mod(nat(n1),100)
      l=ibond(j,1)
      l1=ibond(j,2)
      if (abs(plan(n)).lt.tolp.and.abs(plan(n1)).lt.tolp) then
      write(ips,'(a12)') '[] 0 setdash'
      write(ips,'(a3,f9.2,1x,a3)') '/x1',xa(n),'def'
      write(ips,'(a3,f9.2,1x,a3)') '/y1',ya(n),'def'
      write(ips,'(a3,f9.2,1x,a3)') '/x2',xa(n1),'def'
      write(ips,'(a3,f9.2,1x,a3)') '/y2',ya(n1),'def'
C
       if(icol.ne.0) then
       write(ips,'(3f5.2,1x,a11)') (atrgb(k,i),i=1,3),'setrgbcolor'
       else
       write(ips,'(f5.3,1x,a7)') atgray(k),'setgray'
       endif
      write(ips,'(a8)') 'dostick1'
       if(icol.ne.0) then
       write(ips,'(3f5.2,1x,a11)') (atrgb(k1,i),i=1,3),'setrgbcolor'
       else
       write(ips,'(f5.3,1x,a7)') atgray(k1),'setgray'
       endif
      write(ips,'(a8)') 'dostick2'
      else
      write(ips,'(a15)') '[1 2] 0 setdash'
      write(ips,'(a3,f9.2,1x,a3)') '/x1',xa(n),'def'
      write(ips,'(a3,f9.2,1x,a3)') '/y1',ya(n),'def'
      write(ips,'(a3,f9.2,1x,a3)') '/x2',xa(n1),'def'
      write(ips,'(a3,f9.2,1x,a3)') '/y2',ya(n1),'def'
      write(ips,'(a9)') '0 setgray'
      write(ips,'(a8)') 'dostick1'
      write(ips,'(a8)') 'dostick2'
      endif
10    continue     
      return
      end
