
C     *****************************************************
C
C                    CrGraph Package V2.0
C                       SELECT Program
C
C      Theoretical Chemistry Group - University of Torino
C
C     *****************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      character*2 symbat
      parameter (lim016=10000)
      common/atomi/paret(3,3),xa(3,lim016),nat(lim016),NAF,LDIM
      common/symbat/symbat(lim016)
      common /framedat/XAA,YAA,ZAA,XB,YB,ZB,XC,YC,ZC
      PARAMETER (MATDIM=500*500,MAXM=20)
      DIMENSION RMAT(MATDIM),RDUM(MATDIM),NRC(0:MAXM),FAT(MAXM),IPOT(1)
      COMMON /FILES/IPLOT,ISCR,IMF,IUHF,IFERMI,IIN,IOUT
      IPLOT=25
      ISCR=19
      IOUT=6
      WRITE(IOUT,*) 'Select program'
      READ(5,*)NSUM
      IF(NSUM.EQ.0.OR.NSUM.GT.MAXM)THEN
      WRITE(IOUT,100)NSUM
      ENDIF
100   FORMAT(' NUMBER OF CONTRIBUTIONS NOT ALLOWED:',I6)
      READ(5,*)(NRC(J),FAT(J),J=1,ABS(NSUM))
      write(iout,101)nsum,(NRC(J),FAT(J),J=1,ABS(NSUM))
101   format(' number of contributions',i3/(i2,'x',f5.2:'+'))
      NRC(0)=0
      DO  J=1,ABS(NSUM) 
      IF(NRC(J)-NRC(J-1).LE.0)THEN
      WRITE(IOUT,205)(NRC(I),I=1,ABS(NSUM))
205   FORMAT(' SEQUENCE NOT CORRECT (MUST BE ASCENDING)'/20I3)
      STOP
      ENDIF    
      ENDDO
C *** MISCELLANEA DATA FROM FORT.25 - MAPS DATA ON FORT.19
C *** WEIGHTED DATA FOR THE UNIQUE MAP ON FORT.25
      CALL EXTRACT(RMAT,IPOT)
      RMAT(1:matdim)=0.D0
      DO 2 J=1,ABS(NSUM)
      WRITE (6,*)' COMPONENT N.',J,' BLOCK N.',NRC(J),' WEIGHT',FAT(J)
      NSKIP=NRC(J)-NRC(J-1)-1
      IF(NSKIP.NE.0)CALL SKIPFW(ISCR,NSKIP)
      CALL RMAPLO(ISCR,TY,RDUM,NR,NC,DXR,DXC,COSF)
      IF(J.EQ.1)THEN
      NRRIF=NR
      NCRIF=NC
      NELEM=NR*NC
      ELSE
      IF((NR-NRRIF)+(NC-NCRIF).NE.0)THEN
      WRITE(IOUT,203)NRRIF,NCRIF,NR,NC
      STOP
      ENDIF
      ENDIF
      DO I=1,NELEM
      RMAT(I)=RMAT(I)+FAT(J)*RDUM(I)
      ENDDO
2     CONTINUE
      BMIN=MINVAL(RMAT(1:nelem))
      BMAX=MAXval(RMAT(1:nelem))
      WRITE(IOUT,201)NR,NC,BMIN,BMAX
      IF(ABS(BMIN-BMAX).LT.1E-8)WRITE(IOUT,204)
201   FORMAT(' FINAL DATA MATRIX ',I3,' x ',I3,' VMIN',1P,E14.6,
     *' VMAX',E14.6)
203   FORMAT(' BLOCK OF DATA OF DIFFERENT SIZE: REFERENCE (1ST BLOCK)'
     *,2I4,' CURRENT',2I4)
      IF(NSUM.LT.0)CALL MATPRT(RMAT,NR,NC,NR,NC,6)
      REWIND ISCR
      MARK=0
      WRITE(IPLOT,202)MARK,TY,NR,NC,DXR,DXC,COSF
      WRITE(IPLOT,221)XAA,YAA,ZAA,XB,YB,ZB,XC,YC,ZC,NAF,LDIM
      WRITE(IPLOT,220)(RMAT(I),I=1,NELEM)
      do ii=1,naf
      write(iplot,1062)nat(ii),SYMBAT(ii),(XA(K,ii),K=1,3)
      enddo
      WRITE(IPLOT,110)((PARET(I,J),J=1,3),I=1,3)
      REWIND IPLOT
110   FORMAT(3E20.12)
202   FORMAT('-%-',I1,A4,2I5,3E12.5)
204   FORMAT(' THE DATA RANGE IS LESS THAN 1E-8')
220   FORMAT(1P,6E12.5)
221   FORMAT(1P,6E12.5/3E12.5,4X,2I4)
1062  FORMAT(I4,1X,A,1P,3E20.12)
      STOP
      END
C***./ ADD NAME=SKIPFW
      SUBROUTINE SKIPFW(IPLOT,NSKIP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*4 TY
      do 1 ISK=1,NSKIP
      READ(IPLOT,200,END=999)IHFERM,TY,NR,NC,DXR,DXC,COSF
      READ(IPLOT,221,END=999)XAA,YAA,ZAA,XB,YB,ZB,XC,YC,ZC,NAF,LDIM
      NELEM=NR*NC
      READ(IPLOT,220,END=999)(RMAT,J=1,NELEM)
      do i=1,naf
      read(iplot,200)idum
      enddo
      read(iplot,110)(adum,i=1,9)
1     CONTINUE
110   FORMAT(3E20.12)
220   FORMAT(1P,6E12.5)
221   FORMAT(1P,6E12.5/3E12.5,4X,2I4)
200   FORMAT(3X,I1,A4,2I4,3E12.5)
201   FORMAT(' SKIPPING - END OF DATA ON FORTRAN UNIT 25')
      RETURN
999   WRITE(6,201)
      STOP
      END
C***./ ADD NAME=RMAPLO
      SUBROUTINE RMAPLO(IPLOT,TY,RMAT,NR,NC,DXR,DXC,COSF)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*4 TY
      parameter (lim016=10000)
      character*2 symbat
      common/atomi/paret(3,3),xa(3,lim016),nat(lim016),NAF,LDIM
      common/symbat/symbat(lim016)
      common /framedat/XAA,YAA,ZAA,XB,YB,ZB,XC,YC,ZC
      DIMENSION RMAT(*)
      READ(IPLOT,200,END=999)IHFERM,TY,NR,NC,DXR,DXC,COSF
      READ(IPLOT,221,END=999)XAA,YAA,ZAA,XB,YB,ZB,XC,YC,ZC,NAF,LDIM
      NELEM=NR*NC
      READ(IPLOT,220,END=999)(RMAT(J),J=1,NELEM)
      do ii=1,naf
      read(iplot,1062)nat(ii),SYMBAT(ii),(XA(K,ii),K=1,3)
      enddo
      READ(IPLOT,110)((PARET(I,J),J=1,3),I=1,3)
      WRITE(6,250)NELEM,NR,NC,IPLOT,XAA,YAA,ZAA,XB,YB,ZB,NR,
     *XC,YC,ZC,NR,NC
110   FORMAT(3E20.12)
250   FORMAT(I5,' DATA  (',I5,',',I5,') READ FROM UNIT',I3/
     *' COORDINATES OF THE 3 POINTS:'/
     *      T15,'A)',3F9.3,' POINT INDICES (  1,  1)'/
     *      T15,'B)',3F9.3,' POINT INDICES (',I3,',  1)'/
     *      T15,'C)',3F9.3,' POINT INDICES (',I3,',',I3,')')
220   FORMAT(1P,6E12.5)
221   FORMAT(1P,6E12.5/3E12.5,4X,2I4)
200   FORMAT(3X,I1,A4,2I5,3E12.5)
201   FORMAT(' MAP PLOT - END OF DATA ON FORTRAN UNIT 25')
1062  FORMAT(I4,1X,A,1P,3E20.12)
      RETURN
999   WRITE(6,201)
      STOP
      END
      SUBROUTINE EXTRACT(RMAT,IPOT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      parameter (lim016=10000)
      CHARACTER*4 TY
      character*2 symbat
      common/atomi/paret(3,3),xa(3,lim016),nat(lim016),NAF,LDIM
      common/symbat/symbat(lim016)
      common /framedat/XAA,YAA,ZAA,XB,YB,ZB,XC,YC,ZC
      COMMON /FILES/IPLOT,ISCR,IMF,IUHF,IFERMI,IIN,IOUT
      DIMENSION RMAT(*),IPOT(*)
      IMAP=0
10    READ(IPLOT,200,END=999)MARK,TY,NR,NC,DXR,DXC,COSF
      print *,mark,ty
      NELEM=NR*NC
      IF(TY.EQ.'MAPN')THEN
      WRITE(ISCR,202)MARK,TY,NR,NC,DXR,DXC,COSF
      READ(IPLOT,221)XAA,YAA,ZAA,XB,YB,ZB,XC,YC,ZC,NAF,LDIM
      WRITE(ISCR,221)XAA,YAA,ZAA,XB,YB,ZB,XC,YC,ZC,NAF,LDIM
      IMAP=IMAP+1
      IPOT(IMAP)=0
      IUHF=MOD(MARK,2)
      READ(IPLOT,220)(RMAT(II),II=1,NELEM)
      WRITE(ISCR,220)(RMAT(II),II=1,NELEM)
      BMIN=MINVAL(RMAT(1:NELEM))
      BMAX=MAXVAL(RMAT(1:NELEM))
      do ii=1,naf
      read(iplot,1062)nat(ii),SYMBAT(ii),
     *(XA(K,ii),K=1,3)
      write(iscr,1062)nat(ii),SYMBAT(ii),
     *(XA(K,ii),K=1,3)
      enddo
      READ(IPLOT,110)((PARET(I,J),J=1,3),I=1,3)
      WRITE(iscr,110)((PARET(I,J),J=1,3),I=1,3)
      IF(BMIN.LT.0.D0)IPOT(IMAP)=1
      WRITE(IOUT,203)IMAP,NR,(NR-1)*DXR,NC,(NC-1)*DXC,COSF,
     *BMIN,BMAX
      ELSE
      READ(IPLOT,200)IDUM
      READ(IPLOT,200)IDUM
      READ(IPLOT,220)(ADUM,I=1,NELEM)
      ENDIF
      GOTO 10
999   WRITE(IOUT,201)IMAP
      IF(IMAP.EQ.0)STOP
      REWIND IPLOT
      REWIND ISCR
      RETURN
110   FORMAT(3E20.12)
200   FORMAT(3X,I1,A4,2I5,3E12.5)
202   FORMAT('-%-',I1,A4,2I5,3E12.5)
201   FORMAT(' END OF DATA ON FORTRAN UNIT 25 -',I3,' DATA MATRICES')
203   FORMAT(' MAP N.',I3,' NROW, AB',I4,1P,E12.4,' NCOL,BC',I4,E12.4,
     *' COS ANGLE',F8.3/10x,' VALMIN',E12.4,' VALMAX',E12.4)
210   FORMAT(2I4,5F10.6)
220   FORMAT(1P,6E12.5)
221   FORMAT(1P,6E12.5/3E12.5,4X,2I4)
1062  FORMAT(I4,1X,A,1P,3E20.12)
      END
      SUBROUTINE MATPRT(A,NR,NC,NDR,NDC,IOUT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(NDR,NDC)
      DO 80 M=1,NC,10
      K=M+9
      IF(K.LE.NC)GO TO 30
2     K=NC
30    CONTINUE
      WRITE(IOUT,40)(J,J=M,K)
      DO 60 I=1,NR
      WRITE(IOUT,50)I,(A(I,J),J=M,K)
60    CONTINUE
80    CONTINUE
40    FORMAT(//7X,10(4X,I3,5X)/)
50    FORMAT(I4,3X,10(E12.4))
      RETURN
      END
